-- MySQL dump 10.13  Distrib 5.5.45, for CYGWIN (x86_64)
--
-- Host: opendof.cgpsbxtk6c3z.us-west-1.rds.amazonaws.com    Database: interface_repository
-- ------------------------------------------------------
-- Server version	5.6.22-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Current Database: `interface_repository`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `interface_repository` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `interface_repository`;

--
-- Table structure for table `interface`
--

DROP TABLE IF EXISTS `interface`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `interface` (
  `ifacePk` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'interface primary autoincrementing key of interfaces',
  `iid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The globally unique Interface ID',
  `xml` text COLLATE utf8_bin NOT NULL COMMENT 'The interface source XML',
  `version` varchar(64) COLLATE utf8_bin NOT NULL COMMENT 'interface version',
  `repotype` tinytext COLLATE utf8_bin NOT NULL COMMENT 'The repository type (i.e. opendof, allseen)',
  `submitterFk` bigint(10) unsigned NOT NULL COMMENT 'The creators Fk',
  `creationDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Time of first entry',
  `modifiedDate` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The last time the xml column was modified',
  `published` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Boolean flag indicating if the interface is working or published',
  PRIMARY KEY (`ifacePk`),
  UNIQUE KEY `iid_index` (`iid`,`version`),
  KEY `creator-fk` (`submitterFk`),
  CONSTRAINT `interfaceSubmitterFk` FOREIGN KEY (`submitterFk`) REFERENCES `submitter` (`submitterPk`)
) ENGINE=InnoDB AUTO_INCREMENT=62 DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='The interface xml containment table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `interface`
--

LOCK TABLES `interface` WRITE;
/*!40000 ALTER TABLE `interface` DISABLE KEYS */;
INSERT INTO `interface` VALUES (2,'[1:{01000048}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000048}]\">\n    <md:code-name>GPSLocation</md:code-name>\n    <md:display-name xml:lang=\"en\">GPS Location</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents a location in the real world defined as latitude, longitude, and elevation using the WGS84 datum.</md:description>\n    <typedefs>\n        <float64 type-id=\"0\" min=\"-90.0\" max=\"90.0\">\n            <md:code-name>Latitude</md:code-name>\n            <md:display-name xml:lang=\"en\">Latitude</md:display-name>\n            <md:description xml:lang=\"en\">The latitude component of the GPS location.</md:description>\n            <unit>Degrees (°) north of the equator.  Negative values represent degrees south of the equator.</unit>\n        </float64>\n        <float64 type-id=\"1\" min=\"-180.0\" max=\"180.0\">\n            <md:code-name>Longitude</md:code-name>\n            <md:display-name xml:lang=\"en\">Longitude</md:display-name>\n            <md:description xml:lang=\"en\">The longitude component of the GPS location.</md:description>\n            <unit>Degrees (°) east of the Prime Meridian (Royal Observatory, Greenwich, England).  Negative values represent degrees west of the Prime Meridian.</unit>\n        </float64>\n        <float64 type-id=\"2\" min=\"-10000.0\" max=\"10000.0\">\n            <md:code-name>Elevation</md:code-name>\n            <md:display-name xml:lang=\"en\">Elevation</md:display-name>\n            <md:description xml:lang=\"en\">The elevation component of the GPS location.</md:description>\n            <unit>Meters (m) above sea-level.</unit>\n        </float64>\n        <structure type-id=\"3\">\n            <md:code-name>Location</md:code-name>\n            <md:display-name xml:lang=\"en\">Location</md:display-name>\n            <md:description xml:lang=\"en\">The location consisting of latitude, longitude, and elevation using the WGS84 datum.</md:description>\n            <field type-ref=\"0\">\n                <md:display-name xml:lang=\"en\">Latitude</md:display-name>\n                <md:description xml:lang=\"en\">The latitude component of the GPS location</md:description>\n            </field>\n            <field type-ref=\"1\">\n                <md:display-name xml:lang=\"en\">Longitude</md:display-name>\n                <md:description xml:lang=\"en\">The longitude component of the GPS location</md:description>\n            </field>\n            <field type-ref=\"2\">\n                <md:display-name xml:lang=\"en\">Elevation</md:display-name>\n                <md:description xml:lang=\"en\">The elevation component of the GPS location.</md:description>\n            </field>\n        </structure>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"3\" read=\"true\" write=\"false\">\n            <md:code-name>location</md:code-name>\n            <md:display-name xml:lang=\"en\">location</md:display-name>\n            <md:description xml:lang=\"en\">The GPS location.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:20','2015-09-28 11:47:20',0),(3,'[1:{01000049}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000049}]\">\n    <md:code-name>Impact</md:code-name>\n    <md:display-name xml:lang=\"en\">Impact</md:display-name>\n    <md:description xml:lang=\"en\">This interface is used for impact force measurement and excessive force reporting.</md:description>\n    <typedefs>\n        <float64 type-id=\"0\" min=\"-90.0\" max=\"90.0\">\n            <md:code-name>Latitude</md:code-name>\n            <md:display-name xml:lang=\"en\">Latitude</md:display-name>\n            <md:description xml:lang=\"en\">The latitude component of the GPS location.</md:description>\n            <unit>Degrees (°) north of the equator.  Negative values represent degrees south of the equator.</unit>\n        </float64>\n        <float64 type-id=\"1\" min=\"-180.0\" max=\"180.0\">\n            <md:code-name>Longitude</md:code-name>\n            <md:display-name xml:lang=\"en\">Longitude</md:display-name>\n            <md:description xml:lang=\"en\">The longitude component of the GPS location.</md:description>\n            <unit>Degrees (°) east of the Prime Meridian (Royal Observatory, Greenwich, England).  Negative values represent degrees west of the Prime Meridian.</unit>\n        </float64>\n        <float64 type-id=\"2\" min=\"-10000.0\" max=\"10000.0\">\n            <md:code-name>Elevation</md:code-name>\n            <md:display-name xml:lang=\"en\">Elevation</md:display-name>\n            <md:description xml:lang=\"en\">The elevation component of the GPS location.</md:description>\n            <unit>Meters (m) above sea-level.</unit>\n        </float64>\n        <structure type-id=\"3\">\n            <md:code-name>Location</md:code-name>\n            <md:display-name xml:lang=\"en\">Location</md:display-name>\n            <md:description xml:lang=\"en\">The location consisting of latitude, longitude, and elevation using the WGS84 datum.</md:description>\n            <field type-ref=\"0\">\n                <md:display-name xml:lang=\"en\">Latitude</md:display-name>\n                <md:description xml:lang=\"en\">The latitude component of the GPS location</md:description>\n            </field>\n            <field type-ref=\"1\">\n                <md:display-name xml:lang=\"en\">Longitude</md:display-name>\n                <md:description xml:lang=\"en\">The longitude component of the GPS location</md:description>\n            </field>\n            <field type-ref=\"2\">\n                <md:display-name xml:lang=\"en\">Elevation</md:display-name>\n                <md:description xml:lang=\"en\">The elevation component of the GPS location.</md:description>\n            </field>\n        </structure>\n        <nullable type-id=\"4\" type-ref=\"3\">\n            <md:code-name>NullableLocation</md:code-name>\n            <md:display-name xml:lang=\"en\">NullableLocation</md:display-name>\n            <md:description xml:lang=\"en\">A nullable GPS location.</md:description>\n        </nullable>\n        <float32 type-id=\"5\" min=\"-1.0\" max=\"1.0\">\n            <md:code-name>Direction</md:code-name>\n            <md:display-name xml:lang=\"en\">Direction</md:display-name>\n            <md:description xml:lang=\"en\">The normalized length of the force vector along the specific axis.</md:description>\n        </float32>\n        <float64 type-id=\"6\" min=\"0.0\" max=\"1.7976931348623157E308\">\n            <md:code-name>Magnitude</md:code-name>\n            <md:display-name xml:lang=\"en\">Magnitude</md:display-name>\n            <md:description xml:lang=\"en\">The length of the force vector.</md:description>\n            <unit>Standard Gravity (g)</unit>\n        </float64>\n        <structure type-id=\"7\">\n            <md:code-name>Force</md:code-name>\n            <md:display-name xml:lang=\"en\">Force</md:display-name>\n            <md:description xml:lang=\"en\">The force vector, which contains the direction component and the magnitude component.  The direction is the 3-tuple (i.e., {x, y, z}) of a Euclidian unit vector.</md:description>\n            <field type-ref=\"5\">\n                <md:display-name xml:lang=\"en\">X</md:display-name>\n                <md:description xml:lang=\"en\">The normalized force vector direction along the \'X\' axis.</md:description>\n            </field>\n            <field type-ref=\"5\">\n                <md:display-name xml:lang=\"en\">Y</md:display-name>\n                <md:description xml:lang=\"en\">>The normalized force vector direction along the \'Y\' axis.</md:description>\n            </field>\n            <field type-ref=\"5\">\n                <md:display-name xml:lang=\"en\">Z</md:display-name>\n                <md:description xml:lang=\"en\">The normalized force vector direction along the \'Z\' axis.</md:description>\n            </field>\n            <field type-ref=\"6\">\n                <md:display-name xml:lang=\"en\">Magnitude</md:display-name>\n                <md:description xml:lang=\"en\">The magnitude of the force vector.</md:description>\n            </field>\n        </structure>\n    </typedefs>\n    <properties>\n        <property item-id=\"2\" type-ref=\"6\" read=\"true\" write=\"true\">\n            <md:code-name>threshold</md:code-name>\n            <md:display-name xml:lang=\"en\">threshold</md:display-name>\n            <md:description xml:lang=\"en\">The threshold for triggered events.  Any impact that occurs with a force magnitude greater than this threshold, will trigger an \'impact\' event.</md:description>\n        </property>\n    </properties>\n    <events>\n        <event item-id=\"1\">\n            <md:code-name>impact</md:code-name>\n            <md:display-name xml:lang=\"en\">impact</md:display-name>\n            <md:description xml:lang=\"en\">An impact has occurred.  The parameters include the date/time and location of the event as well as the force along each axis.</md:description>\n            <outputs>\n                <output type-ref=\"4\">\n                    <md:display-name xml:lang=\"en\">location</md:display-name>\n                    <md:description xml:lang=\"en\">Where the impact occurred.</md:description>\n                </output>\n                <output type-ref=\"7\">\n                    <md:display-name xml:lang=\"en\">force</md:display-name>\n                    <md:description xml:lang=\"en\">The force vector.</md:description>\n                </output>\n            </outputs>\n        </event>\n    </events>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:21','2015-09-28 11:47:21',0),(5,'[1:{0100004A}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0100004A}]\">\n    <md:code-name>LocationHistory</md:code-name>\n    <md:display-name xml:lang=\"en\">Location History</md:display-name>\n    <md:description xml:lang=\"en\">This interface is used to get a location history.</md:description>\n    <typedefs>\n        <float64 type-id=\"0\" min=\"-90.0\" max=\"90.0\">\n            <md:code-name>Latitude</md:code-name>\n            <md:display-name xml:lang=\"en\">Latitude</md:display-name>\n            <md:description xml:lang=\"en\">The latitude component of the GPS location.</md:description>\n            <unit>Degrees (°) north of the equator.  Negative values represent degrees south of the equator.</unit>\n        </float64>\n        <float64 type-id=\"1\" min=\"-180.0\" max=\"180.0\">\n            <md:code-name>Longitude</md:code-name>\n            <md:display-name xml:lang=\"en\">Longitude</md:display-name>\n            <md:description xml:lang=\"en\">The longitude component of the GPS location.</md:description>\n            <unit>Degrees (°) east of the Prime Meridian (Royal Observatory, Greenwich, England).  Negative values represent degrees west of the Prime Meridian.</unit>\n        </float64>\n        <float64 type-id=\"2\" min=\"-10000.0\" max=\"10000.0\">\n            <md:code-name>Elevation</md:code-name>\n            <md:display-name xml:lang=\"en\">Elevation</md:display-name>\n            <md:description xml:lang=\"en\">The elevation component of the GPS location.</md:description>\n            <unit>Meters (m) above sea-level.</unit>\n        </float64>\n        <structure type-id=\"3\">\n            <md:code-name>Location</md:code-name>\n            <md:display-name xml:lang=\"en\">Location</md:display-name>\n            <md:description xml:lang=\"en\">The location consisting of latitude, longitude, and elevation using the WGS84 datum.</md:description>\n            <field type-ref=\"0\">\n                <md:display-name xml:lang=\"en\">Latitude</md:display-name>\n                <md:description xml:lang=\"en\">The latitude component of the GPS location</md:description>\n            </field>\n            <field type-ref=\"1\">\n                <md:display-name xml:lang=\"en\">Longitude</md:display-name>\n                <md:description xml:lang=\"en\">The longitude component of the GPS location</md:description>\n            </field>\n            <field type-ref=\"2\">\n                <md:display-name xml:lang=\"en\">Elevation</md:display-name>\n                <md:description xml:lang=\"en\">The elevation component of the GPS location.</md:description>\n            </field>\n        </structure>\n        <datetime type-id=\"4\">\n            <md:code-name>Timestamp</md:code-name>\n            <md:display-name xml:lang=\"en\">Timestamp</md:display-name>\n            <md:description xml:lang=\"en\">A date/time timestamp.</md:description>\n        </datetime>\n        <structure type-id=\"5\">\n            <md:code-name>LocationChange</md:code-name>\n            <md:display-name xml:lang=\"en\">LocationChange</md:display-name>\n            <md:description xml:lang=\"en\">A location change.</md:description>\n            <field type-ref=\"4\">\n                <md:display-name xml:lang=\"en\">Timestamp</md:display-name>\n                <md:description xml:lang=\"en\">When the location was changed.</md:description>\n            </field>\n            <field type-ref=\"3\">\n                <md:display-name xml:lang=\"en\">Location</md:display-name>\n                <md:description xml:lang=\"en\">The new location.</md:description>\n            </field>\n        </structure>\n        <array type-id=\"6\" type-ref=\"5\" min-length=\"0\" length=\"10000\">\n            <md:code-name>LocationChanges</md:code-name>\n            <md:display-name xml:lang=\"en\">LocationChanges</md:display-name>\n            <md:description xml:lang=\"en\">An array of location changes.</md:description>\n        </array>\n        <uint16 type-id=\"7\">\n            <md:code-name>Count</md:code-name>\n            <md:display-name xml:lang=\"en\">Count</md:display-name>\n            <md:description xml:lang=\"en\">A request count.</md:description>\n        </uint16>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>recentHistory</md:code-name>\n            <md:display-name xml:lang=\"en\">recentHistory</md:display-name>\n            <md:description xml:lang=\"en\">Get the recent history.</md:description>\n            <inputs>\n                <input type-ref=\"7\">\n                    <md:code-name>count</md:code-name>\n                    <md:display-name xml:lang=\"en\">count</md:display-name>\n                    <md:description xml:lang=\"en\">Get at most this many history entries.</md:description>\n                </input>\n            </inputs>\n            <outputs>\n                <output type-ref=\"6\">\n                    <md:code-name>locations</md:code-name>\n                    <md:display-name xml:lang=\"en\">locations</md:display-name>\n                    <md:description xml:lang=\"en\">The location history results.</md:description>\n                </output>\n            </outputs>\n        </method>\n        <method item-id=\"2\">\n            <md:code-name>clear</md:code-name>\n            <md:display-name xml:lang=\"en\">clear</md:display-name>\n            <md:description xml:lang=\"en\">Clears the known location history.</md:description>\n        </method>\n    </methods>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:21','2015-09-28 11:47:21',0),(6,'[1:{0100004B}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0100004B}]\">\n    <md:code-name>Lockable</md:code-name>\n    <md:display-name xml:lang=\"en\">Lockable</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents anything that is lockable.</md:description>\n    <typedefs>\n        <boolean type-id=\"0\">\n            <md:code-name>LockState</md:code-name>\n            <md:display-name xml:lang=\"en\">LockState</md:display-name>\n            <md:description xml:lang=\"en\">The lock state of the item.  True means locked and false means unlocked.</md:description>\n        </boolean>\n    </typedefs>\n    <properties>\n        <property item-id=\"3\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:code-name>isLocked</md:code-name>\n            <md:display-name xml:lang=\"en\">isLocked</md:display-name>\n            <md:description xml:lang=\"en\">This is the current lock state of the item.</md:description>\n        </property>\n    </properties>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>lock</md:code-name>\n            <md:display-name xml:lang=\"en\">lock</md:display-name>\n            <md:description xml:lang=\"en\">Lock the item.  This may fail if not currently lockable.  In that case, the Failed exception is thrown.</md:description>\n        </method>\n        <method item-id=\"2\">\n            <md:code-name>unlock</md:code-name>\n            <md:display-name xml:lang=\"en\">unlock</md:display-name>\n            <md:description xml:lang=\"en\">Unlock the item.  This may fail if the item is not currently unlockable.  In that case, the Failed exception is thrown.</md:description>\n        </method>\n    </methods>\n    <exceptions>\n        <exception item-id=\"4\">\n            <md:code-name>failed</md:code-name>\n            <md:display-name xml:lang=\"en\">failed</md:display-name>\n            <md:description xml:lang=\"en\">This exception may occur when the item cannot be locked or unlocked.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:21','2015-09-28 11:47:21',0),(23,'[1:{01000054}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000054}]\">\n    <md:code-name>Temporary Password Credentials</md:code-name>\n    <md:display-name xml:lang=\"en\">Temporary Password Credentials</md:display-name>\n    <md:description xml:lang=\"en\">This interface is used to request temporary password credentials. Temporary credentials are DOF credentials that are only valid for a short time, primarily designed to allow access in conjuction with a presentation or demo. The interface has reduced security requirements because of the nature of the credentials. The object id of the object providing this interface should be a known id for the presentation or demo.</md:description>\n    <typedefs>\n        <oid type-id=\"1\">\n            <md:code-name>Identity</md:code-name>\n            <md:display-name xml:lang=\"en\">Identity</md:display-name>\n            <md:description xml:lang=\"en\">An object id used as an identity.</md:description>\n        </oid>\n        <string type-id=\"2\" encoding=\"3\" length=\"32\">\n            <md:code-name>Password</md:code-name>\n            <md:display-name xml:lang=\"en\">Password</md:display-name>\n            <md:description xml:lang=\"en\">A password string.</md:description>\n        </string>\n        <blob type-id=\"3\" min-length=\"1\" length=\"4096\">\n            <md:code-name>Permission Set</md:code-name>\n            <md:display-name xml:lang=\"en\">Permission Set</md:display-name>\n            <md:description xml:lang=\"en\">A blob representing a permissions set.</md:description>\n        </blob>\n        <datetime type-id=\"4\">\n            <md:code-name>Expiry</md:code-name>\n            <md:display-name xml:lang=\"en\">Expiry</md:display-name>\n            <md:description xml:lang=\"en\">An expiration date.</md:description>\n        </datetime>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>requestCredentials</md:code-name>\n            <md:display-name xml:lang=\"en\">requestCredentials</md:display-name>\n            <md:description xml:lang=\"en\">Request temporary credentials. This method will return temporary credentials that will expire at the specified expiration date. \n	If the same unique identifier is supplied this method will return the same credentials up to the expiry date.</md:description>\n            <inputs>\n                <input type-ref=\"1\">\n                    <md:code-name>Unique Identifier</md:code-name>\n                    <md:display-name xml:lang=\"en\">Unique Identifier</md:display-name>\n                    <md:description xml:lang=\"en\">The unique identifier of the device that is requesting credentials. This identifier will be associated with the temporary credentials that are returned.</md:description>\n                </input>\n            </inputs>\n            <outputs>\n                <output type-ref=\"1\">\n                    <md:code-name>Identity</md:code-name>\n                    <md:display-name xml:lang=\"en\">Identity</md:display-name>\n                    <md:description xml:lang=\"en\">The identity of the credentials. This identity may not match the unique identifier passed as an input value.</md:description>\n                </output>\n                <output type-ref=\"2\">\n                    <md:code-name>Password</md:code-name>\n                    <md:display-name xml:lang=\"en\">Password</md:display-name>\n                    <md:description xml:lang=\"en\">The password of the credentials. These password should not be encrypted.</md:description>\n                </output>\n                <output type-ref=\"3\">\n                    <md:code-name>Permission Set</md:code-name>\n                    <md:display-name xml:lang=\"en\">Permissions Set</md:display-name>\n                    <md:description xml:lang=\"en\">The permissions set that is assigned to the temporary credentials. This can be used to set permission on secure components created with the temporary credentials, and to get which object ids can be used for provider and requestor object.</md:description>\n                </output>\n                <output type-ref=\"4\">\n                    <md:code-name>Expiry</md:code-name>\n                    <md:display-name xml:lang=\"en\">Expiry</md:display-name>\n                    <md:description xml:lang=\"en\">The date when these credentials expire.</md:description>\n                </output>\n            </outputs>\n        </method>\n    </methods>\n    <exceptions>\n        <exception item-id=\"2\">\n            <md:code-name>failed</md:code-name>\n            <md:display-name xml:lang=\"en\">Failed</md:display-name>\n            <md:description xml:lang=\"en\">This exception occurs when credentials could not be created.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:26','2015-09-28 11:47:26',0),(24,'[1:{01000023}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface \n    xmlns=\"http://opendof.org/schema/interface-repository\" \n    xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" \n    xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" \n    xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \"\n    iid=\"[1:{01000023}]\">\n	<md:code-name>TOASTER</md:code-name>\n	<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n	<md:display-name xml:lang=\"en\">Toaster</md:display-name>\n	<md:description xml:lang=\"ja\">翻訳希望</md:description>\n	<md:description xml:lang=\"en\">This interface represents a toaster. The definition includes all the required functionality. This toaster can toast one set of bread at a time.</md:description>\n	<typedefs>\n		<boolean type-id=\"0\">\n			<md:code-name>Powered</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Powered State</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">A power state (on/off). True means \'on\'.</md:description>\n		</boolean>\n		<uint8 type-id=\"1\">\n			<md:code-name>Intensity</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Intensity</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">An indication of desired intensity. The larger the number, the more intense.</md:description>\n		</uint8>\n		<uint8 type-id=\"2\">\n			<md:code-name>Mode</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Mode</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">A mode for a toaster. The allowed values are: 0, toast, 1, bagel.</md:description>\n		</uint8>\n		<blob type-id=\"3\" length=\"65535\">\n			<md:code-name>PNGImage</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">PNG Image</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">A PNG image.</md:description>\n		</blob>\n		<nullable type-id=\"4\" type-ref=\"3\">\n			<md:code-name>NullablePNGImage</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Nullable PNG Image</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">A PNG image that also allows a NULL value.</md:description>\n		</nullable>\n	</typedefs>\n	<properties>\n		<property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"true\">\n			<md:code-name>powered</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Powered</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">The power state of the toaster.</md:description>\n		</property>\n		<property item-id=\"2\" type-ref=\"1\" read=\"true\" write=\"true\">\n			<md:code-name>intensity</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Desired Intensity</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">The desired intensity of the toasting.</md:description>\n		</property>\n		<property item-id=\"3\" type-ref=\"2\" read=\"true\" write=\"true\">\n			<md:code-name>mode</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Mode</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">The mode the toaster is in.</md:description>\n		</property>\n	</properties>\n	<methods>\n		<method item-id=\"4\">\n			<md:code-name>cancel</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Cancel</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">Cancel the current toasting.</md:description>\n		</method>\n		<method item-id=\"5\">\n			<md:code-name>setStamp</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Set Stamp</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">Set the stamp to use for future toast. Null indicates no stamp.</md:description>\n			<inputs>\n				<input type-ref=\"4\">\n					<md:code-name>stamp</md:code-name>\n					<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n					<md:display-name xml:lang=\"en\">Stamp</md:display-name>\n					<md:description xml:lang=\"ja\">翻訳希望</md:description>\n					<md:description xml:lang=\"en\">The desired stamp, or null.</md:description>\n				</input>\n			</inputs>\n		</method>\n	</methods>\n	<events>\n		<event item-id=\"6\">\n			<md:code-name>done</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Done</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">Indicates that a toasting operation has completed.</md:description>\n		</event>\n		<event item-id=\"7\">\n			<md:code-name>burning</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Burning</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">Indicates that the toast is burning.</md:description>\n		</event>\n	</events>\n	<exceptions>\n		<exception item-id=\"8\">\n			<md:code-name>notToasting</md:code-name>\n			<md:display-name xml:lang=\"ja\">翻訳希望</md:display-name>\n			<md:display-name xml:lang=\"en\">Not Toasting</md:display-name>\n			<md:description xml:lang=\"ja\">翻訳希望</md:description>\n			<md:description xml:lang=\"en\">Indicates that the toaster is not toasting, and so a request is not valid.</md:description>\n		</exception>\n	</exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:26','2015-09-28 11:47:26',0),(25,'[1:{0100004C}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0100004C}]\">\n    <md:code-name>Weight</md:code-name>\n    <md:display-name xml:lang=\"en\">Weight</md:display-name>\n    <md:description xml:lang=\"en\">This interface is used for checking the physical weight of an object.</md:description>\n    <typedefs>\n        <float64 type-id=\"0\" min=\"0.0\" max=\"1.7976931348623157E308\">\n            <md:code-name>Weight</md:code-name>\n            <md:display-name xml:lang=\"en\">Weight</md:display-name>\n            <md:description xml:lang=\"en\">The physical weight of the object.</md:description>\n            <unit>Kilograms (kg)</unit>\n        </float64>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:code-name>weight</md:code-name>\n            <md:display-name xml:lang=\"en\">weight</md:display-name>\n            <md:description xml:lang=\"en\">The current weight of the object.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:26','2015-09-28 11:47:26',0),(26,'[1:{01000000}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000000}]\">\n    <md:code-name>TRAINING_BASE</md:code-name>\n    <md:display-name xml:lang=\"ja\">トレーニング用ベースインターフェース</md:display-name>\n    <md:display-name xml:lang=\"en\">Training Base Interface</md:display-name>\n    <md:description xml:lang=\"ja\">\n        このインターフェースにはアイテムが含まれていない。EMITオブジェクトは、他のトレーニングインターフェース上でもセッションを提供する場合、このインターフェースを提供する。\n        <![CDATA[<br>\n        <h3>Associated Interfaces</h3>\n   	    <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000001\">Waveform</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000002\">Event Interface</a></li>\n   	    </ul>]]>\n    </md:description>\n    <md:description xml:lang=\"en\">\n        This interface contains no items. EMIT objects provide this interface if they also provide a session on other training interfaces.\n        <![CDATA[<br>\n        <h3>Associated Interfaces</h3>\n   	    <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000001\">Waveform</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000002\">Event Interface</a></li>\n   	    </ul>]]>\n    </md:description>\n    <typedefs>\n    </typedefs>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:27','2015-09-28 11:59:15',1),(27,'[1:{01000022}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000022}]\">\n    <md:code-name>DATAMANAGER</md:code-name>\n    <md:display-name xml:lang=\"en\">Data Manager</md:display-name>\n    <md:description xml:lang=\"en\">\n        This interface is provided by the data manager. There is a single data manager for each distinct instance of a data platform.\n  	    <![CDATA[<br><h3>Associated Interfaces</h3>\n        <tab id=t1>Basics\n        <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.0225\">Data Sink</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.0226\">Data Source</a></li>\n        </ul>\n        <tab id=t1>Snapshot\n        <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.0228\">Data Snapshot</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000027\">Data Snapshot Config</a></li>\n        </ul>\n        <tab id=t1>Topology\n        <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000028\">Data Topology Update</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.0227\">Data Topology Info</a></li>\n        </ul>\n        ]]>\n    </md:description>\n    <typedefs>\n        <oid type-id=\"1\">                                                                                               \n            <md:code-name>ID</md:code-name>\n            <md:display-name xml:lang=\"en\">ID\n            </md:display-name>\n            <md:description xml:lang=\"en\">Identifier for different actors in the data exchange (device, source, sink, parent).</md:description>\n        </oid>\n        <string type-id=\"2\" encoding=\"3\" length=\"32767\">\n            <md:code-name>Notification</md:code-name>\n            <md:display-name xml:lang=\"en\">Notification</md:display-name>\n            <md:description xml:lang=\"en\"><![CDATA[A notification message that is targetted for a human rather than a program, in HTML format. The text will begin with an \'<html>\' tag and end with an \'</html>\' tag.]]></md:description>\n        </string>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>Notify</md:code-name>\n            <md:display-name xml:lang=\"en\">Notify</md:display-name>\n            <md:description xml:lang=\"en\">Send a notification based on the input parameters. There is no response and no failure mode - it is assumed that a failure to deliver the notification will (internally) cause some other administrative notification.</md:description>\n            <inputs>\n                <input type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">deviceID</md:display-name>\n                    <md:description xml:lang=\"en\">The device that the notification applies to.</md:description>\n                </input>\n                <input type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">rootID</md:display-name>\n                    <md:description xml:lang=\"en\">The top-most (root) parent that the node applies to. The manager may not be aware of the complete topology, and so may not be able to easily determine an appropriate notification recipient. This parameter offloads the manager by providing the top-most parent, which should be sufficient to determine the appropriate recipient.</md:description>\n                </input>\n                <input type-ref=\"2\">\n                    <md:display-name xml:lang=\"en\">notification</md:display-name>\n                    <md:description xml:lang=\"en\">The notification content.</md:description>\n                </input>\n            </inputs>\n        </method>\n    </methods>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:27','2015-09-28 11:59:16',1),(28,'[1:{0225}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0225}]\">\n    <md:code-name>DATASINK</md:code-name>\n    <md:display-name xml:lang=\"en\">Data Sink</md:display-name>\n    <md:description xml:lang=\"en\">\n        This interface is used by a data source to advertise data, events, and topology to a configured data sink. In addition to defining methods, this interface also defines types that are used as the specification for various persistent storage formats. These storage formats are associated with the IID of this interface and identified with \'[storage]\' in their descriptions. Further, there are unused types defined that correspond to the formatting data blocks before compression. In this case the compressed field is passed on the wire, and the unused type defines the format and contents of the block before compression. These types are identified by putting \'[formatting]\' in their descriptions.\n  	    <![CDATA[<br><h3>Associated Interfaces</h3>\n        <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000022\">Data Manager</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.0226\">Data Source</a></li>\n        </ul>]]>\n    </md:description>\n    <typedefs>\n        <iid type-id=\"18\">\n            <md:code-name>SinkVersion</md:code-name>\n            <md:display-name xml:lang=\"en\">Sink Version</md:display-name>\n            <md:description xml:lang=\"en\">[storage] An IID used to identify the version of stored information related to the sink API. Future versions of this interface will need to differentiate between versions. All stored data defined by this interface will begin with this type, allowing it to be read to identify the data format that follows.</md:description>\n        </iid>\n        <iid type-id=\"31\">\n            <md:code-name>SourceVersion</md:code-name>\n            <md:display-name xml:lang=\"en\">Source Version</md:display-name>\n            <md:description xml:lang=\"en\">[storage] An IID used to identify the version of stored information related to the source IID associated with this sink IID. Future versions of this interface will need to differentiate between versions. All stored data defined by the source interface will begin with this type, allowing it to be read to identify the data format that follows.</md:description>\n        </iid>\n        <oid type-id=\"0\">\n            <md:code-name>ID</md:code-name>\n            <md:display-name xml:lang=\"en\">ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for an actor in the data exchange (device, source, sink, parent).</md:description>\n        </oid>\n        <nullable type-id=\"32\" type-ref=\"0\">\n            <md:code-name>OptionalID</md:code-name>\n            <md:display-name xml:lang=\"en\">Optional ID</md:display-name>\n            <md:description xml:lang=\"en\">An optional ID that is used in cases (for example, parent) where the ID may not exist. NULL indicates that there is no ID.</md:description>\n        </nullable>\n        <uint32 type-id=\"1\">\n            <md:code-name>ValueSetID</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for the advertised value set, unique to the sink and source involved in the transfer. When used to either request or acknowledge the value set (using the Data Source interface) this identifier uniquely identifies the value set and the sink it is being transferred to.</md:description>\n        </uint32>\n        <uint32 type-id=\"20\">\n            <md:code-name>EventID</md:code-name>\n            <md:display-name xml:lang=\"en\">Event ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for a signaled event, unique to the sink and source involved in the transfer. When used to acknowledge the event (using the Data Source interface) this identifier uniquely identifies the event and the sink the event is being transferred to.</md:description>\n        </uint32>\n        <uint32 type-id=\"22\">\n            <md:code-name>TopologyID</md:code-name>\n            <md:display-name xml:lang=\"en\">Topology ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for a topology update, unique to the sink and source involved in the transfer. When used to acknowledge the update (using the Data Source interface) this identifier uniquely identifies the update and the sink the event is being transferred to.</md:description>\n        </uint32>\n        <datetime type-id=\"4\">\n            <md:code-name>Time</md:code-name>\n            <md:display-name xml:lang=\"en\">Time</md:display-name>\n            <md:description xml:lang=\"en\">The timestamp used throughout to reference start and end times. Time is always in UTC, as required by the type.</md:description>\n        </datetime>\n        <uint32 type-id=\"5\">\n            <md:code-name>DeltaTime</md:code-name>\n            <md:display-name xml:lang=\"en\">Time Quantum</md:display-name>\n            <md:description xml:lang=\"en\">The number of milliseconds in each quantum of time used in the value transfer.</md:description>\n        </uint32>\n        <uint16 type-id=\"17\">\n            <md:code-name>Position</md:code-name>\n            <md:display-name xml:lang=\"en\">Position</md:display-name>\n            <md:description xml:lang=\"en\">The logical position of the device relative to the parent. The parent defines the context/meaning of the positions for its children. A parent may have multiple children with the same position, which may indicate a grouping or relationship between those children. The position is meta-data associated with the device itself, and not related directly to data or an event.</md:description>\n        </uint16>\n        <nullable type-id=\"30\" type-ref=\"17\">\n            <md:code-name>OptionalPosition</md:code-name>\n            <md:display-name xml:lang=\"en\">Optional Position</md:display-name>\n            <md:description xml:lang=\"en\">An optional position is used in cases where the position may not exist. NULL indicates that there is no position.</md:description>\n        </nullable>\n        <blob type-id=\"3\" min-length=\"0\" length=\"65535\">\n            <md:code-name>ValueSetDefinition</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set Definition</md:display-name>\n            <md:description xml:lang=\"en\">A compressed block that defines the properties that are being transferred in the advertisement. The compression algorithm is DEFLATE (RFC 1951). The uncompressed block is an EMIT-marshalled instance of the \'Uncompressed Value Set Definition\' type defined in this interface.</md:description>\n        </blob>\n        <nullable type-id=\"34\" type-ref=\"3\">\n            <md:code-name>OptionalValueSetDefinition</md:code-name>\n            <md:display-name xml:lang=\"en\">Optional Value Set Definition</md:display-name>\n            <md:description xml:lang=\"en\">[storage] Either a value set definition or a NULL if the definition is not present.</md:description>\n        </nullable>\n        <uint32 type-id=\"7\">\n            <md:code-name>ValueSetDefinitionAlias</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set Definition Alias</md:display-name>\n            <md:description xml:lang=\"en\">An alias for the Value Set Definition, assigned by the sink and optionally used by the source.</md:description>\n        </uint32>\n        <blob type-id=\"21\" min-length=\"0\" length=\"65535\">\n            <md:code-name>Event</md:code-name>\n            <md:display-name xml:lang=\"en\">Event</md:display-name>\n            <md:description xml:lang=\"en\">A compressed block that describes both the event definition that is being transferred in the signal and the event parameters. The compression algorithm is DEFLATE (RFC 1951). The uncompressed block is an EMIT-marshalled instance of the \'Uncompressed Event\' type defined in this interface.</md:description>\n        </blob>\n        <iid type-id=\"9\">\n            <md:code-name>ElementIID</md:code-name>\n            <md:display-name xml:lang=\"en\">Element IID</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] The IID of a property or event (collectively, element) that can be passed.</md:description>\n        </iid>\n        <uint16 type-id=\"10\" min=\"0\" max=\"32767\">\n            <md:code-name>PropertyItemID</md:code-name>\n            <md:display-name xml:lang=\"en\">Property Item ID</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A property item ID.</md:description>\n        </uint16>\n        <uint16 type-id=\"25\" min=\"0\" max=\"32767\">\n            <md:code-name>EventItemID</md:code-name>\n            <md:display-name xml:lang=\"en\">Event Item ID</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] An event item ID.</md:description>\n        </uint16>\n        <uint8 type-id=\"11\">\n            <md:code-name>PropertyAggregationMethod</md:code-name>\n            <md:display-name xml:lang=\"en\">Property Aggregation Method</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A number that identifies the aggregation method used for this property. The following values are defined; any other values are not defined and must be rejected. RAW(0) - No aggregation is done. AVEDEV(1) - The average of the absolute deviations from the mean. AVERAGE(2) - The average (arithmetic mean). GEOMEAN(3) - The geometric mean. MAX(4) - The maximum value. MEDIAN(5) - The number in the middle of the values. MIN(6) - The minimum value. STDDEV(7) - The standard deviation. VAR(8) - The variance. FIRST(9) - The first value in the sequence. LAST(10) - The last value in the sequence.</md:description>\n        </uint8>\n        <structure type-id=\"13\">\n            <md:code-name>PropertyDefinition</md:code-name>\n            <md:display-name xml:lang=\"en\">Property Definition</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] The definition of a property that will be exchanged.</md:description>\n            <field type-ref=\"9\">\n                <md:display-name xml:lang=\"en\">iid</md:display-name>\n                <md:description xml:lang=\"en\">The IID of the property.</md:description>\n            </field>\n            <field type-ref=\"10\">\n                <md:display-name xml:lang=\"en\">itemID</md:display-name>\n                <md:description xml:lang=\"en\">The item ID of the property.</md:description>\n            </field>\n            <field type-ref=\"11\">\n                <md:display-name xml:lang=\"en\">aggregation</md:display-name>\n                <md:description xml:lang=\"en\">The aggregation method used.</md:description>\n            </field>\n            <field type-ref=\"10\">\n                <md:display-name xml:lang=\"en\">type</md:display-name>\n                <md:description xml:lang=\"en\">The item ID of a property in the reference interface that defines the property type.</md:description>\n            </field>\n        </structure>\n        <array type-id=\"14\" type-ref=\"13\" min-length=\"0\" length=\"32767\">\n            <md:code-name>PropertyDefinitionArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Property Definition Array</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] An variable-length array of property definitions.</md:description>\n        </array>\n        <blob type-id=\"15\" min-length=\"5\" length=\"65535\">\n            <md:code-name>PropertyTypes</md:code-name>\n            <md:display-name xml:lang=\"en\">Reference Interface Definition</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A blob containing an interface definition. The interface definition is defined in the OAP protocol specification, PDU OAP.13.2, as everything that follows the opcode byte of the response to the Define PDU.</md:description>\n        </blob>\n        <structure type-id=\"16\">\n            <md:code-name>NonCompressedValueSetDefinition</md:code-name>\n            <md:display-name xml:lang=\"en\">Uncompressed Value Set Definition</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A structure containing the uncompressed version of the entire value set definition for transfer. Note that this type is never used, but it defines the uncompressed format of a block that is passed on the wire.</md:description>\n            <field type-ref=\"14\">\n                <md:display-name xml:lang=\"en\">properties</md:display-name>\n                <md:description xml:lang=\"en\">An array of property definitions.</md:description>\n            </field>\n            <field type-ref=\"15\">\n                <md:display-name xml:lang=\"en\">types</md:display-name>\n                <md:description xml:lang=\"en\">An interface definition used to store type definitions.</md:description>\n            </field>\n        </structure>\n        <structure type-id=\"23\">\n            <md:code-name>RangeMetadata</md:code-name>\n            <md:display-name xml:lang=\"en\">Range Metadata</md:display-name>\n            <md:description xml:lang=\"en\">This structure defines metadata for data over a range of time.</md:description>\n            <field type-ref=\"0\">\n                <md:display-name xml:lang=\"en\">deviceID</md:display-name>\n                <md:description xml:lang=\"en\">The ID of the device that originated the data.</md:description>\n            </field>\n            <field type-ref=\"32\">\n                <md:display-name xml:lang=\"en\">parentID</md:display-name>\n                <md:description xml:lang=\"en\">The ID of the parent of the device, if applicable.  The parent is meta-data associated with the device itself, and not related directly to data or an event.</md:description>\n            </field>\n            <field type-ref=\"30\">\n                <md:display-name xml:lang=\"en\">position</md:display-name>\n                <md:description xml:lang=\"en\">The position of the device relative to the parent, if applicable. The position is meta-data associated with the device itself, and not related directly to data or an event.</md:description>\n            </field>\n            <field type-ref=\"4\">\n                <md:display-name xml:lang=\"en\">blockStartTime</md:display-name>\n                <md:description xml:lang=\"en\">The time of the first data value in the advertised data block. This time should be aligned on a quantum, and must be rounded to the nearest quantum if it is not.</md:description>\n            </field>\n            <field type-ref=\"5\">\n                <md:display-name xml:lang=\"en\">blockQuantum</md:display-name>\n                <md:description xml:lang=\"en\">The quantum used for each timestamp in the advertised data block. All timestamps will be a multiple of this quantum.</md:description>\n            </field>\n            <field type-ref=\"4\">\n                <md:display-name xml:lang=\"en\">blockEndTime</md:display-name>\n                <md:description xml:lang=\"en\">The time of the last data value in the advertised data block.</md:description>\n            </field>\n        </structure>\n        <structure type-id=\"24\">\n            <md:code-name>DiscreteMetadata</md:code-name>\n            <md:display-name xml:lang=\"en\">Discrete Metadata</md:display-name>\n            <md:description xml:lang=\"en\">This structure defines metadata for data at a single point in time.</md:description>\n            <field type-ref=\"0\">\n                <md:display-name xml:lang=\"en\">deviceID</md:display-name>\n                <md:description xml:lang=\"en\">The ID of the device that originated the data.</md:description>\n            </field>\n            <field type-ref=\"32\">\n                <md:display-name xml:lang=\"en\">parentID</md:display-name>\n                <md:description xml:lang=\"en\">The ID of the parent of the device, if applicable.  The parent is meta-data associated with the device itself, and not related directly to data or an event.</md:description>\n            </field>\n            <field type-ref=\"30\">\n                <md:display-name xml:lang=\"en\">position</md:display-name>\n                <md:description xml:lang=\"en\">The position of the device relative to the parent, if applicable. The position is meta-data associated with the device itself, and not related directly to data or an event.</md:description>\n            </field>\n            <field type-ref=\"4\">\n                <md:display-name xml:lang=\"en\">time</md:display-name>\n                <md:description xml:lang=\"en\">The time associated with the advertised data.</md:description>\n            </field>\n        </structure>\n        <structure type-id=\"27\">\n            <md:code-name>EventDefinition</md:code-name>\n            <md:display-name xml:lang=\"en\">Event Definition</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] The definition of an event that will be exchanged.</md:description>\n            <field type-ref=\"9\">\n                <md:display-name xml:lang=\"en\">iid</md:display-name>\n                <md:description xml:lang=\"en\">The IID of the event.</md:description>\n            </field>\n            <field type-ref=\"25\">\n                <md:display-name xml:lang=\"en\">itemID</md:display-name>\n                <md:description xml:lang=\"en\">The item ID of the event.</md:description>\n            </field>\n            <field type-ref=\"25\">\n                <md:display-name xml:lang=\"en\">type</md:display-name>\n                <md:description xml:lang=\"en\">The item ID of an event in the reference interface that defines the event parameter types.</md:description>\n            </field>\n            <field type-ref=\"15\">\n                <md:display-name xml:lang=\"en\">types</md:display-name>\n                <md:description xml:lang=\"en\">An interface definition used to store type definitions.</md:description>\n            </field>\n        </structure>\n        <blob type-id=\"28\" min-length=\"0\" length=\"65535\">\n            <md:code-name>EventValues</md:code-name>\n            <md:display-name xml:lang=\"en\">Event Values</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A list of marshalled DOFValues matching the parameters of the event being signaled.</md:description>\n        </blob>\n        <structure type-id=\"29\">\n            <md:code-name>UncompressedEvent</md:code-name>\n            <md:display-name xml:lang=\"en\">Uncompressed Event</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A structure containing the entire event for transfer. Note that this type is never used, but it defines the uncompressed format of a block that is passed on the wire.</md:description>\n            <field type-ref=\"27\">\n                <md:display-name xml:lang=\"en\">event</md:display-name>\n                <md:description xml:lang=\"en\">An event definition.</md:description>\n            </field>\n            <field type-ref=\"28\">\n                <md:display-name xml:lang=\"en\">values</md:display-name>\n                <md:description xml:lang=\"en\">The values associated with the event.</md:description>\n            </field>\n        </structure>\n        <structure type-id=\"19\">\n            <md:code-name>ValueSetDefinitionStorage</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set Definition Storage</md:display-name>\n            <md:description xml:lang=\"en\">[storage] This structure defines the peristence storage definition for the value set definition. Note that the format defined in this interface will always use an IID of [1:{0225}]. When reading the stored format the reader must check the version field and read the contents according to the correct IID.</md:description>\n            <field type-ref=\"18\">\n                <md:display-name xml:lang=\"en\">version</md:display-name>\n                <md:description xml:lang=\"en\">This field identifies the version of the stored data. All versions of the storage will start with the same version type, and a generic reader can read the version and identify the format that follows. This definition uses the value [1:{0225}].</md:description>\n            </field>\n            <field type-ref=\"3\">\n                <md:display-name xml:lang=\"en\">valueSetDefinition</md:display-name>\n                <md:description xml:lang=\"en\">The stored value set definition, assuming the version field is the IID of this interface.</md:description>\n            </field>\n        </structure>\n        <blob type-id=\"33\" min-length=\"0\" length=\"1048576\">\n            <md:code-name>ValueSetBlock</md:code-name>\n            <md:display-name xml:lang=\"en\">Source Value Set Block</md:display-name>\n            <md:description xml:lang=\"en\">[storage] This value set is defined by the source IID and corresponds to the information transferred to the sink.</md:description>\n        </blob>\n        <structure type-id=\"8\">\n            <md:code-name>ValueSetStorage</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set Storage</md:display-name>\n            <md:description xml:lang=\"en\">[storage] This type describes the peristent storage format for data sets. All future versions of this interface must maintain the first field (version). Note that the format defined in this interface will always use an IID of [1:{0225}]. When reading the stored format the reader must check the version field and read the contents according to the correct IID.</md:description>\n            <field type-ref=\"18\">\n                <md:display-name xml:lang=\"en\">version</md:display-name>\n                <md:description xml:lang=\"en\">The version of the storage format, defined as the IID that defines the format. All versions of the storage will start with the same version type, and a generic reader can read the version and identify the format that follows. This definition uses the value [1:{0225}].</md:description>\n            </field>\n            <field type-ref=\"23\">\n                <md:display-name xml:lang=\"en\">metaData</md:display-name>\n                <md:description xml:lang=\"en\">The meta-data associated with the value set.</md:description>\n            </field>\n            <field type-ref=\"34\">\n                <md:display-name xml:lang=\"en\">dataDefinition</md:display-name>\n                <md:description xml:lang=\"en\">The compressed representation of the data definition.</md:description>\n            </field>\n            <field type-ref=\"31\">\n                <md:display-name xml:lang=\"en\">sourceVersion</md:display-name>\n                <md:description xml:lang=\"en\">The version of the source storage format, defined as the source IID that defines the format.</md:description>\n            </field>\n            <field type-ref=\"33\">\n                <md:display-name xml:lang=\"en\">sourceData</md:display-name>\n                <md:description xml:lang=\"en\">The block associated with the source and identified by the source version. See the source IID for the definition of the contents of this block.</md:description>\n            </field>\n        </structure>\n        <structure type-id=\"2\">\n            <md:code-name>EventStorage</md:code-name>\n            <md:display-name xml:lang=\"en\">Event Storage</md:display-name>\n            <md:description xml:lang=\"en\">[storage] This type describes the peristent storage format for an event. All future versions of this interface must maintain the first field (version). All versions of the storage will start with the same version type, and a generic reader can read the version and identify the format that follows. This definition uses the value [1:{0225}].</md:description>\n            <field type-ref=\"18\">\n                <md:display-name xml:lang=\"en\">version</md:display-name>\n                <md:description xml:lang=\"en\">The version of the storage format, defined as the IID that defines the format. All versions of the storage will start with the same version type, and a generic reader can read the version and identify the format that follows. This definition uses the value [1:{0225}].</md:description>\n            </field>\n            <field type-ref=\"24\">\n                <md:display-name xml:lang=\"en\">metaData</md:display-name>\n                <md:description xml:lang=\"en\">The meta-data associated with the event.</md:description>\n            </field>\n            <field type-ref=\"21\">\n                <md:display-name xml:lang=\"en\">event</md:display-name>\n                <md:description xml:lang=\"en\">The compressed representation of both the event definition and values.</md:description>\n            </field>\n        </structure>\n        <structure type-id=\"6\">\n            <md:code-name>TopologyStorage</md:code-name>\n            <md:display-name xml:lang=\"en\">Topology Storage</md:display-name>\n            <md:description xml:lang=\"en\">[storage] This type describes the peristent storage format for a topology update. All future versions of this interface must maintain the first field (version). All versions of the storage will start with the same version type, and a generic reader can read the version and identify the format that follows. This definition uses the value [1:{0225}].</md:description>\n            <field type-ref=\"18\">\n                <md:display-name xml:lang=\"en\">version</md:display-name>\n                <md:description xml:lang=\"en\">The version of the storage format, defined as the IID that defines the format. All versions of the storage will start with the same version type, and a generic reader can read the version and identify the format that follows. This definition uses the value [1:{0225}].</md:description>\n            </field>\n            <field type-ref=\"24\">\n                <md:display-name xml:lang=\"en\">metaData</md:display-name>\n                <md:description xml:lang=\"en\">The meta-data associated with the topology update.</md:description>\n            </field>\n        </structure>\n        <uint32 type-id=\"35\">\n            <md:code-name>DetailRequestID</md:code-name>\n            <md:display-name xml:lang=\"en\">Detail Request ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier provided by the sink to a request for detail data made to the source.</md:description>\n        </uint32>\n        <uint8 type-id=\"36\">\n            <md:code-name>DetailRequestStatus</md:code-name>\n            <md:display-name xml:lang=\"en\">Detail Request Status</md:display-name>\n            <md:description xml:lang=\"en\">A code indicating the completion status of the detail request. The following values are defined, other values are illegal and should be treated as errors. COMPLETE(0) - success;  COMPLETE_NO_DATA(1) - no data was found for the requested time and duration; FAILED(2) - general error; CANCELLED(3) - request cancelled;  TIMEOUT(4) -- The request timed out before completing.</md:description>\n        </uint8>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>Advertise</md:code-name>\n            <md:display-name xml:lang=\"en\">Advertise Data</md:display-name>\n            <md:description xml:lang=\"en\">Advertise a value set that the sink may get and must acknowledge. This method may return \'Value Set Definition Not Understood\' if the particular data definition cannot be understood, which would prevent any data transfer for that definition.</md:description>\n            <inputs>\n                <input type-ref=\"0\">\n                    <md:display-name xml:lang=\"en\">sourceID</md:display-name>\n                    <md:description xml:lang=\"en\">The ID of the node responsible for transferring the value set.</md:description>\n                </input>\n                <input type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">valueSetID</md:display-name>\n                    <md:description xml:lang=\"en\">An identifier associated with the advertised value set and the sink, that is used to uniquely identify the value set/sink combination.</md:description>\n                </input>\n                <input type-ref=\"23\">\n                    <md:display-name xml:lang=\"en\">metaData</md:display-name>\n                    <md:description xml:lang=\"en\">The meta-data associated with the value set.</md:description>\n                </input>\n                <input type-ref=\"3\">\n                    <md:display-name xml:lang=\"en\">valueSetDefinition</md:display-name>\n                    <md:description xml:lang=\"en\">The full value set definition associated with the advertised information.</md:description>\n                </input>\n            </inputs>\n            <outputs>\n                <output type-ref=\"7\">\n                    <md:display-name xml:lang=\"en\">valueSetDefinitionAlias</md:display-name>\n                    <md:description xml:lang=\"en\">The alias that the sink wants the source to use to refer to this particular value set definition.</md:description>\n                </output>\n            </outputs>\n        </method>\n        <method item-id=\"2\">\n            <md:code-name>AdvertiseWithAlias</md:code-name>\n            <md:display-name xml:lang=\"en\">Advertise Data With Alias</md:display-name>\n            <md:description xml:lang=\"en\">Advertise a value set using an alias that the sink may get and must acknowledge. This method may cause a Data Definition Alias Not Understood exception.</md:description>\n            <inputs>\n                <input type-ref=\"0\">\n                    <md:display-name xml:lang=\"en\">sourceID</md:display-name>\n                    <md:description xml:lang=\"en\">The ID of the node responsible for transferring the data.</md:description>\n                </input>\n                <input type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">valueSetID</md:display-name>\n                    <md:description xml:lang=\"en\">An identifier associated with the advertised value set and sink, that is used to uniquely identify the value set/sink combination.</md:description>\n                </input>\n                <input type-ref=\"23\">\n                    <md:display-name xml:lang=\"en\">metaData</md:display-name>\n                    <md:description xml:lang=\"en\">The meta-data associated with the value set.</md:description>\n                </input>\n                <input type-ref=\"7\">\n                    <md:display-name xml:lang=\"en\">valueSetDefinitionAlias</md:display-name>\n                    <md:description xml:lang=\"en\">An alias that represents the value set definition that the sink has associated for the source.</md:description>\n                </input>\n            </inputs>\n        </method>\n        <method item-id=\"4\">\n            <md:code-name>Signal</md:code-name>\n            <md:display-name xml:lang=\"en\">Signal Event</md:display-name>\n            <md:description xml:lang=\"en\">Signal and event that the sink must acknowledge. This method does not cause any provider exceptions.</md:description>\n            <inputs>\n                <input type-ref=\"0\">\n                    <md:display-name xml:lang=\"en\">sourceID</md:display-name>\n                    <md:description xml:lang=\"en\">The ID of the node responsible for transferring the event.</md:description>\n                </input>\n                <input type-ref=\"20\">\n                    <md:display-name xml:lang=\"en\">eventID</md:display-name>\n                    <md:description xml:lang=\"en\">An identifier associated with the signaled event and the sink, that is used to uniquely identify the event/sink combination.</md:description>\n                </input>\n                <input type-ref=\"24\">\n                    <md:display-name xml:lang=\"en\">metaData</md:display-name>\n                    <md:description xml:lang=\"en\">The meta-data associated with the event.</md:description>\n                </input>\n                <input type-ref=\"21\">\n                    <md:display-name xml:lang=\"en\">eventDefinition</md:display-name>\n                    <md:description xml:lang=\"en\">The event being signaled, including both definition and values.</md:description>\n                </input>\n            </inputs>\n        </method>\n        <method item-id=\"5\">\n            <md:code-name>UpdateTopology</md:code-name>\n            <md:display-name xml:lang=\"en\">Update Topology</md:display-name>\n            <md:description xml:lang=\"en\">Update the topology of a node. This method does not cause any provider exceptions.</md:description>\n            <inputs>\n                <input type-ref=\"0\">\n                    <md:display-name xml:lang=\"en\">sourceID</md:display-name>\n                    <md:description xml:lang=\"en\">The ID of the node responsible for transferring the update.</md:description>\n                </input>\n                <input type-ref=\"22\">\n                    <md:display-name xml:lang=\"en\">topologyID</md:display-name>\n                    <md:description xml:lang=\"en\">An identifier associated with the update and the sink, that is used to uniquely identify the update/sink combination.</md:description>\n                </input>\n                <input type-ref=\"24\">\n                    <md:display-name xml:lang=\"en\">metaData</md:display-name>\n                    <md:description xml:lang=\"en\">The meta-data associated with the update.</md:description>\n                </input>\n            </inputs>\n        </method>\n        <method item-id=\"6\">\n            <md:code-name>CompleteDetailRequest</md:code-name>\n            <md:display-name xml:lang=\"en\">Detail Request Complete</md:display-name>\n            <md:description xml:lang=\"en\">Notify the sink that a request for detail data has been completed.</md:description>\n            <inputs>\n                <input type-ref=\"35\">\n                    <md:display-name xml:lang=\"en\">id</md:display-name>\n                    <md:description xml:lang=\"en\">The ID of the request for detail data.</md:description>\n                </input>\n                <input type-ref=\"36\">\n                    <md:display-name xml:lang=\"en\">status</md:display-name>\n                    <md:description xml:lang=\"en\">The status of the request for detail data.</md:description>\n                </input>\n            </inputs>\n        </method>\n    </methods>\n    <exceptions>\n        <exception item-id=\"3\">\n            <md:code-name>ValueSetDefinitionAliasNotUnderstood</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set Definition Alias Not Understood</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the sink if the value set definition alias received is not understood. This indicates that the advertise should be resent including the value set definition and a new alias obtained.</md:description>\n        </exception>\n        <exception item-id=\"7\">\n            <md:code-name>ValueSetDefinitionNotUnderstood</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set Definition Not Understood</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the sink if the value set definition received is not understood. This indicates some formatting issue on the source, or a programming error on the sink. Resubmitting the same definition will likely resultin the same exception, so this can be considered fatal for the definition in question and would prevent any data transfer.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:27','2015-09-28 11:59:16',1),(29,'[1:{0228}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0228}]\">\n    <md:code-name>DATASNAPSHOT</md:code-name>\n    <md:display-name xml:lang=\"en\">Data Snapshot</md:display-name>\n    <md:description xml:lang=\"en\">\n        This interface provides a snapshot of a known, public reference interface for a binding. This interface is typically activated on demand using an object id containing the Binding Provider attribute, which indicates the public reference interface for which this interface provides a snapshot. In this case, the definition will be the set of readable properties of the reference interface, in order of ascending item ID. Alternately, the referenced interface may merely define a constant set of properties (possibly from multiple, disparate interfaces) that comprise the snapshot. Finally, this interface may be provided on a session where the definition may be defined some other way (within the context of the session).\n  	    <![CDATA[<br><h3>Associated Interfaces</h3>\n        <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000022\">Data Manager</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000027\">Data Snapshot Config</a></li>\n        </ul>]]>\n    </md:description>\n    <typedefs>\n        <datetime type-id=\"0\">\n            <md:code-name>Timestamp</md:code-name>\n            <md:display-name xml:lang=\"en\">Timestamp</md:display-name>\n            <md:description xml:lang=\"en\">A timestamp.</md:description>\n        </datetime>\n        <uint16 type-id=\"1\">\n            <md:code-name>Property</md:code-name>\n            <md:display-name xml:lang=\"en\">Property</md:display-name>\n            <md:description xml:lang=\"en\">A property index, with zero being the first property.</md:description>\n        </uint16>\n        <uint16 type-id=\"2\">\n            <md:code-name>Count</md:code-name>\n            <md:display-name xml:lang=\"en\">Count</md:display-name>\n            <md:description xml:lang=\"en\">A count of data values used to produce a property value, which can be zero to indicate that the property is not present in the property values list.</md:description>\n        </uint16>\n        <structure type-id=\"3\">\n            <md:code-name>PropertyInfo</md:code-name>\n            <md:display-name xml:lang=\"en\">Property Information</md:display-name>\n            <md:description xml:lang=\"en\">A structure containing a property index and the count for that property. If the count is the default for the snapshot then no structure is necessary.</md:description>\n            <field type-ref=\"1\">\n                <md:display-name xml:lang=\"en\">property</md:display-name>\n                <md:description xml:lang=\"en\">The property index.</md:description>\n            </field>\n            <field type-ref=\"2\">\n                <md:display-name xml:lang=\"en\">count</md:display-name>\n                <md:description xml:lang=\"en\">The count for the property.</md:description>\n            </field>\n        </structure>\n        <array type-id=\"4\" type-ref=\"3\" min-length=\"0\" length=\"32767\">\n            <md:code-name>PropertyInfoArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Property Information Array</md:display-name>\n            <md:description xml:lang=\"en\">A variable array of Property Information structures indicating properties that have non-default counts. This can be used to \'skip\' properties (a zero count) or indicate that a non-default number of samples were used in the case of aggregate data.</md:description>\n        </array>\n        <blob type-id=\"5\" min-length=\"0\" length=\"1048576\">\n            <md:code-name>Values</md:code-name>\n            <md:display-name xml:lang=\"en\">Property Values</md:display-name>\n            <md:description xml:lang=\"en\">A block of EMIT-marshalled values corresponding to the snapshot values at a particular time. These are marshalled in the same order as the snapshot definition.</md:description>\n        </blob>\n        <structure type-id=\"6\">\n            <md:code-name>Snapshot</md:code-name>\n            <md:display-name xml:lang=\"en\">Snapshot</md:display-name>\n            <md:description xml:lang=\"en\">The information for a snapshot, including the timestamp and property data. This corresponds to a single Row type, but outside of the context of a Value Set, defined by the Data Source [{01}:{0226}] interface.</md:description>\n            <field type-ref=\"0\">\n                <md:display-name xml:lang=\"en\">timestamp</md:display-name>\n                <md:description xml:lang=\"en\">The timestamp of the snapshot.</md:description>\n            </field>\n            <field type-ref=\"2\">\n                <md:display-name xml:lang=\"en\">defaultCount</md:display-name>\n                <md:description xml:lang=\"en\">The default count for the snapshot.</md:description>\n            </field>\n            <field type-ref=\"4\">\n                <md:display-name xml:lang=\"en\">propertyCounts</md:display-name>\n                <md:description xml:lang=\"en\">A list of exceptions to the default count value for properties in this snapshot.</md:description>\n            </field>\n            <field type-ref=\"5\">\n                <md:display-name xml:lang=\"en\">propertyValues</md:display-name>\n                <md:description xml:lang=\"en\">The values for the properties with non-zero counts.</md:description>\n            </field>\n        </structure>\n        <blob type-id=\"7\" min-length=\"0\" length=\"65535\">\n            <md:code-name>Definition</md:code-name>\n            <md:display-name xml:lang=\"en\">Definition</md:display-name>\n            <md:description xml:lang=\"en\">A compressed block that defines the properties that are being transferred in the advertisement. The compression algorithm is DEFLATE (RFC 1951). The uncompressed block is an EMIT-marshalled instance of the \'Uncompressed Value Set Definition\' type defined in the Data Sink [{01}:{0225}] interface.</md:description>\n        </blob>\n    </typedefs>\n    <properties>\n        <property item-id=\"0\" type-ref=\"7\" read=\"true\" write=\"false\">\n            <md:code-name>definition</md:code-name>\n            <md:display-name xml:lang=\"en\">Definition</md:display-name>\n            <md:description xml:lang=\"en\">The full definition of the data held in the Snapshot property of this interface.</md:description>\n        </property>\n        <property item-id=\"1\" type-ref=\"6\" read=\"true\" write=\"false\">\n            <md:code-name>snapshot</md:code-name>\n            <md:display-name xml:lang=\"en\">Snapshot</md:display-name>\n            <md:description xml:lang=\"en\">The snapshot.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:27','2015-09-28 11:59:16',1),(30,'[1:{01000027}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000027}]\">\n    <md:code-name>DATASNAPSHOTCONFIG</md:code-name>\n    <md:display-name xml:lang=\"en\">Data Snapshot Configuration</md:display-name>\n    <md:description xml:lang=\"en\">\n        This interface provides a way to configure the contents of a Data Snapshot interface. This must only be provided on a session, where the session state provides the context and state between this configured definition and the Data Snapshot interface (also provided on the session, after this interface is used to configure the provided definition). This interface should no longer be provided on the session once the definition has been set (a new session should be established for a different definition).\n  	    <![CDATA[<br><h3>Associated Interfaces</h3>\n        <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000022\">Data Manager</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.0228\">Data Snapshot</a></li>\n        </ul>]]>\n    </md:description>\n    <typedefs>\n        <blob type-id=\"7\" min-length=\"0\" length=\"65535\">\n            <md:code-name>Definition</md:code-name>\n            <md:display-name xml:lang=\"en\">Definition</md:display-name>\n            <md:description xml:lang=\"en\">A compressed block that defines the properties that are being transferred in the advertisement. The compression algorithm is DEFLATE (RFC 1951). The uncompressed block is an EMIT-marshalled instance of the \'Uncompressed Value Set Definition\' type defined in the Data Sink [{01}:{0225}] interface.</md:description>\n        </blob>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>setDefinition</md:code-name>\n            <md:display-name xml:lang=\"en\">Set Definition</md:display-name>\n            <md:description xml:lang=\"en\">Request to provide the specified definition of data via the Data Snapshot interface on the current session.</md:description>\n            <inputs>\n                <input type-ref=\"7\">\n                    <md:display-name xml:lang=\"en\">definition</md:display-name>\n                    <md:description xml:lang=\"en\">The definition.</md:description>\n                </input>\n            </inputs>\n        </method>\n    </methods>\n    <exceptions>\n        <exception item-id=\"2\">\n            <md:code-name>notUnderstood</md:code-name>\n            <md:display-name xml:lang=\"en\">Definition Not Understood</md:display-name>\n            <md:description xml:lang=\"en\">Returned from the method if the definition received is not understood. This indicates some formatting issue on the requestor, or a programming error on the provider. Resubmitting the same definition will likely result in the same exception, so this can be considered fatal for the definition in question and would prevent any data transfer.</md:description>\n        </exception>\n        <exception item-id=\"3\">\n            <md:code-name>notAvailable</md:code-name>\n            <md:display-name xml:lang=\"en\">Not Available</md:display-name>\n            <md:description xml:lang=\"en\">Returned from the method if the definition received cannot be provided. This indicates the provider is not capable of providing the requested definition (e.g., unimplemented interfaces, properties, or aggregation types). Resubmitting the same definition will likely result in the same exception, so this can be considered fatal for the definition in question and would prevent any data transfer.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:28','2015-09-28 11:59:17',1),(31,'[1:{0226}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0226}]\">\n    <md:code-name>DATASOURCE</md:code-name>\n    <md:display-name xml:lang=\"en\">Data Source</md:display-name>\n    <md:description xml:lang=\"en\">\n        This interface is used by a sink to get and acknowledge value sets, events, and topology updates based on an advertisement from a data source. It is also used to request detail data from sources that provided aggregated data. There are unused types defined that correspond to the formatting data blocks before compression. In this case the compressed field is passed on the wire, and the unused type defines the format and contents of the block before compression. These types are identified by putting \'[formatting]\' in their descriptions.\n  	    <![CDATA[<br><h3>Associated Interfaces</h3>\n        <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000022\">Data Manager</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.0225\">Data Sink</a></li>\n        </ul>]]>\n    </md:description>\n    <typedefs>\n        <uint32 type-id=\"1\">\n            <md:code-name>ValueSetID</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for the advertised value set, unique to the sink and source involved in the transfer. When used to either get or acknowledge the value set this identifier uniquely identifies the value set and the sink it is being transferred to.</md:description>\n        </uint32>\n        <uint32 type-id=\"2\">\n            <md:code-name>EventID</md:code-name>\n            <md:display-name xml:lang=\"en\">Event ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for a signaled event, unique to the sink and source involved in the transfer. When used to acknowledge the event this identifier uniquely identifies the event and the sink the event is being transferred to.</md:description>\n        </uint32>\n        <uint32 type-id=\"3\">\n            <md:code-name>TopologyID</md:code-name>\n            <md:display-name xml:lang=\"en\">Topology ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for a topology update, unique to the sink and source involved in the transfer. When used to acknowledge the update this identifier uniquely identifies the update and the sink the event is being transferred to.</md:description>\n        </uint32>\n        <uint32 type-id=\"15\">\n            <md:code-name>DetailRequestID</md:code-name>\n            <md:display-name xml:lang=\"en\">Detail Request ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for a detail request made by the sink, unique to the sink.</md:description>\n        </uint32>\n        <blob type-id=\"4\" min-length=\"0\" length=\"1048576\">\n            <md:code-name>ValueSet</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set</md:display-name>\n            <md:description xml:lang=\"en\">A compressed block that contains property values and timestamps that are being transferred to the sink. The compression algorithm is DEFLATE (RFC 1951). The uncompressed block is an EMIT-marshalled instance of the \'Uncompressed Value Set\' type defined in this interface.</md:description>\n        </blob>\n        <blob type-id=\"5\" min-length=\"0\" length=\"1048576\">\n            <md:code-name>PropertyValues</md:code-name>\n            <md:display-name xml:lang=\"en\">Property Values</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A block of EMIT-marshalled values corresponding to the value set definition values at a particular time. These are marshalled in the same order as the value set definition.</md:description>\n        </blob>\n        <uint16 type-id=\"6\">\n            <md:code-name>Column</md:code-name>\n            <md:display-name xml:lang=\"en\">Column</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A column index, with zero being the first column.</md:description>\n        </uint16>\n        <uint16 type-id=\"7\">\n            <md:code-name>Count</md:code-name>\n            <md:display-name xml:lang=\"en\">Count</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A count of data values used to produce a column value, which can be zero to indicate that the column is not present in the property values list.</md:description>\n        </uint16>\n        <structure type-id=\"8\">\n            <md:code-name>ColumnCount</md:code-name>\n            <md:display-name xml:lang=\"en\">Column Information</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A structure containing a column and the count for that column. If the count is the default for the row then no structure is necessary.</md:description>\n            <field type-ref=\"6\">\n                <md:display-name xml:lang=\"en\">column</md:display-name>\n                <md:description xml:lang=\"en\">The column index.</md:description>\n            </field>\n            <field type-ref=\"7\">\n                <md:display-name xml:lang=\"en\">count</md:display-name>\n                <md:description xml:lang=\"en\">The count for the column.</md:description>\n            </field>\n        </structure>\n        <array type-id=\"9\" type-ref=\"8\" min-length=\"0\" length=\"32767\">\n            <md:code-name>ColumnCountArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Column Information Array</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] A variable array of Column Count structures indicating columns that have non-default counts. This can be used to \'skip\' columns (a zero count) or indicate that a non-default number of samples were used in the case of aggregate data.</md:description>\n        </array>\n        <uint8 type-id=\"12\">\n            <md:code-name>DeltaTime</md:code-name>\n            <md:display-name xml:lang=\"en\">Delta Time</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] The timestamp of a row, expressed as the number of time quanta from the timestamp of the previous row.</md:description>\n        </uint8>\n        <structure type-id=\"13\">\n            <md:code-name>Row</md:code-name>\n            <md:display-name xml:lang=\"en\">Row</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] The information for a row, including the timestamp and column data.</md:description>\n            <field type-ref=\"12\">\n                <md:display-name xml:lang=\"en\">delta</md:display-name>\n                <md:description xml:lang=\"en\">The timestamp, represented as a delta of quanta from the previous row.</md:description>\n            </field>\n            <field type-ref=\"7\">\n                <md:display-name xml:lang=\"en\">defaultCount</md:display-name>\n                <md:description xml:lang=\"en\">The default count for the row.</md:description>\n            </field>\n            <field type-ref=\"9\">\n                <md:display-name xml:lang=\"en\">columnCounts</md:display-name>\n                <md:description xml:lang=\"en\">A list of exceptions to the default count value for columns in this row.</md:description>\n            </field>\n            <field type-ref=\"5\">\n                <md:display-name xml:lang=\"en\">propertyValues</md:display-name>\n                <md:description xml:lang=\"en\">The values for the properties with non-zero counts.</md:description>\n            </field>\n        </structure>\n        <array type-id=\"14\" type-ref=\"13\" min-length=\"1\" length=\"32767\">\n            <md:code-name>UncompressedValueSet</md:code-name>\n            <md:display-name xml:lang=\"en\">Uncompressed Value Set</md:display-name>\n            <md:description xml:lang=\"en\">[formatting] An array of rows.</md:description>\n        </array>\n        <oid type-id=\"16\">\n            <md:code-name>ID</md:code-name>\n            <md:display-name xml:lang=\"en\">ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for an actor in the data exchange (device, source, sink, parent).</md:description>\n        </oid>\n        <iid type-id=\"17\">\n            <md:code-name>PropertyIID</md:code-name>\n            <md:display-name xml:lang=\"en\">Property IID</md:display-name>\n            <md:description xml:lang=\"en\">The identifier for a property interface.</md:description>\n        </iid>\n        <uint16 type-id=\"18\" min=\"0\" max=\"32767\">\n            <md:code-name>PropertyItemID</md:code-name>\n            <md:display-name xml:lang=\"en\">Property Item ID</md:display-name>\n            <md:description xml:lang=\"en\">A property item ID.</md:description>\n        </uint16>\n        <datetime type-id=\"19\">\n            <md:code-name>Timestamp</md:code-name>\n            <md:display-name xml:lang=\"en\">Timestamp</md:display-name>\n            <md:description xml:lang=\"en\">A timestamp.</md:description>\n        </datetime>\n        <uint32 type-id=\"20\">\n            <md:code-name>Milliseconds</md:code-name>\n            <md:display-name xml:lang=\"en\">Milliseconds</md:display-name>\n            <md:description xml:lang=\"en\">A time range in milliseconds.</md:description>\n        </uint32>\n        <structure type-id=\"21\">\n            <md:code-name>Request</md:code-name>\n            <md:display-name xml:lang=\"en\">Request</md:display-name>\n            <md:description xml:lang=\"en\">A request for detail data. This information may be sent to multiple sources without modification in cases where sources contain partial information for the time range desired.</md:description>\n            <field type-ref=\"16\">\n                <md:display-name xml:lang=\"en\">device</md:display-name>\n                <md:description xml:lang=\"en\">The device that provided the aggregate data and that detail data should be provided for.</md:description>\n            </field>\n            <field type-ref=\"17\">\n                <md:display-name xml:lang=\"en\">propertyIID</md:display-name>\n                <md:description xml:lang=\"en\">The IID of the property to return detail data about.</md:description>\n            </field>\n            <field type-ref=\"18\">\n                <md:display-name xml:lang=\"en\">propertyItemID</md:display-name>\n                <md:description xml:lang=\"en\">The Item ID of the property to return detail data about.</md:description>\n            </field>\n            <field type-ref=\"19\">\n                <md:display-name xml:lang=\"en\">startTime</md:display-name>\n                <md:description xml:lang=\"en\">The start time of the detail data to return.</md:description>\n            </field>\n            <field type-ref=\"20\">\n                <md:display-name xml:lang=\"en\">timeRange</md:display-name>\n                <md:description xml:lang=\"en\">The time range of the detail data to return.</md:description>\n            </field>\n        </structure>\n        <uint32 type-id=\"10\">\n            <md:code-name>QueuedValueSetCount</md:code-name>\n            <md:display-name xml:lang=\"en\">Queued Value Set Count</md:display-name>\n            <md:description xml:lang=\"en\">The number of Value Sets that are queued for delivery to the sink.</md:description>\n        </uint32>\n        <uint16 type-id=\"22\">\n            <md:code-name>Hours</md:code-name>\n            <md:display-name xml:lang=\"en\">Hours</md:display-name>\n            <md:description xml:lang=\"en\">A time range in hours.</md:description>\n        </uint16>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>Get</md:code-name>\n            <md:display-name xml:lang=\"en\">Get</md:display-name>\n            <md:description xml:lang=\"en\">Retrieve a value set from a source. This may cause an Unknown Value Set Identifier exception.</md:description>\n            <inputs>\n                <input type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">valueSetID</md:display-name>\n                    <md:description xml:lang=\"en\">The value set identifier to return.</md:description>\n                </input>\n            </inputs>\n            <outputs>\n                <output type-ref=\"4\">\n                    <md:display-name xml:lang=\"en\">valueSet</md:display-name>\n                    <md:description xml:lang=\"en\">The value set.</md:description>\n                </output>\n            </outputs>\n        </method>\n        <method item-id=\"2\">\n            <md:code-name>AcknowledgeValueSet</md:code-name>\n            <md:display-name xml:lang=\"en\">Acknowledge Value Set</md:display-name>\n            <md:description xml:lang=\"en\">Acknowledge the transfer of a value set from a source. This does not return an exception even if the identifier is not found.</md:description>\n            <inputs>\n                <input type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">valueSetID</md:display-name>\n                    <md:description xml:lang=\"en\">The value set identifier to acknowledge.</md:description>\n                </input>\n            </inputs>\n            <outputs>\n                <output type-ref=\"10\">\n                    <md:display-name xml:lang=\"en\">queuedValueSetCount</md:display-name>\n                    <md:description xml:lang=\"en\">The number of value sets still queued for the sink. Note that the sink is understood through the Value Set ID of the method.</md:description>\n                </output>\n            </outputs>\n        </method>\n        <method item-id=\"4\">\n            <md:code-name>AcknowledgeEvent</md:code-name>\n            <md:display-name xml:lang=\"en\">Acknowledge Event</md:display-name>\n            <md:description xml:lang=\"en\">Acknowledge the transfer of an event from a source. This does not return an exception even if the identifier is not found.</md:description>\n            <inputs>\n                <input type-ref=\"2\">\n                    <md:display-name xml:lang=\"en\">eventID</md:display-name>\n                    <md:description xml:lang=\"en\">The event identifier to acknowledge.</md:description>\n                </input>\n            </inputs>\n        </method>\n        <method item-id=\"5\">\n            <md:code-name>AcknowledgeTopologyUpdate</md:code-name>\n            <md:display-name xml:lang=\"en\">Acknowledge Topology Update</md:display-name>\n            <md:description xml:lang=\"en\">Acknowledge the transfer of a topology update from a source. This does not return an exception even if the identifier is not found.</md:description>\n            <inputs>\n                <input type-ref=\"3\">\n                    <md:display-name xml:lang=\"en\">updateID</md:display-name>\n                    <md:description xml:lang=\"en\">The topology update identifier to acknowledge.</md:description>\n                </input>\n            </inputs>\n        </method>\n        <method item-id=\"6\">\n            <md:code-name>RequestDetail</md:code-name>\n            <md:display-name xml:lang=\"en\">Request Detail</md:display-name>\n            <md:description xml:lang=\"en\">Initiate a request for detail data. All data for the request and notification of its completion will be sent to the indicated sink. This may throw the Out of Range, Unknown Data, Unknown Sink, Out of Resource, or Duplicate RequestID exceptions.</md:description>\n            <inputs>\n                <input type-ref=\"15\">\n                    <md:display-name xml:lang=\"en\">requestID</md:display-name>\n                    <md:description xml:lang=\"en\">An identifier to associate with this request. The combination of this ID and the sink should be unique.</md:description>\n                </input>\n                <input type-ref=\"16\">\n                    <md:display-name xml:lang=\"en\">sink</md:display-name>\n                    <md:description xml:lang=\"en\">The target sink for the data. This sink follows the distribution rules for sinks, meaning that the request will be load-balanced based on the presence of provider attributes.</md:description>\n                </input>\n                <input type-ref=\"21\">\n                    <md:display-name xml:lang=\"en\">request</md:display-name>\n                    <md:description xml:lang=\"en\">A structure containing information about the request.</md:description>\n                </input>\n                <input type-ref=\"20\">\n                    <md:display-name xml:lang=\"en\">timeout</md:display-name>\n                    <md:description xml:lang=\"en\">The max duration that the sink is willing to wait for a response.</md:description>\n                </input>\n            </inputs>\n        </method>\n        <method item-id=\"7\">\n            <md:code-name>CancelRequestDetail</md:code-name>\n            <md:display-name xml:lang=\"en\">Cancel Request Detail</md:display-name>\n            <md:description xml:lang=\"en\">Cancel a request for detail data by a sink. The requesting sink and request ID are provided. This does not return an exception even if the request ID is not found.</md:description>\n            <inputs>\n                <input type-ref=\"15\">\n                    <md:display-name xml:lang=\"en\">requestID</md:display-name>\n                    <md:description xml:lang=\"en\">The identifier associated with this request. The combination of this ID and the sink should be unique.</md:description>\n                </input>\n                <input type-ref=\"16\">\n                    <md:display-name xml:lang=\"en\">sink</md:display-name>\n                    <md:description xml:lang=\"en\">The sink that requested the data.</md:description>\n                </input>\n            </inputs>\n        </method>\n    </methods>\n    <exceptions>\n        <exception item-id=\"3\">\n            <md:code-name>UnknownValueSetIdentifier</md:code-name>\n            <md:display-name xml:lang=\"en\">Unknown Value Set Identifier</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the source if the value set identifier is not recognized.</md:description>\n        </exception>\n        <exception item-id=\"8\">\n            <md:code-name>OuteOfRange</md:code-name>\n            <md:display-name xml:lang=\"en\">Out of Range</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the source if a request for detailed data is outside the time range for which the source stores data or if the specified request timeout is greater than the source allows. Includes the max allowed request duration, timeout and historical age.</md:description>\n            <outputs>\n                <output type-ref=\"22\">\n                    <md:display-name xml:lang=\"en\">Max Historical Age</md:display-name>\n                    <md:description xml:lang=\"en\">The maximum time, in hours, that the source will store detailed data.</md:description>\n                </output>\n                <output type-ref=\"20\">\n                    <md:display-name xml:lang=\"en\">Max Duration</md:display-name>\n                    <md:description xml:lang=\"en\">The maximum request duration allowed by the source.</md:description>\n                </output>\n                <output type-ref=\"20\">\n                    <md:display-name xml:lang=\"en\">Max Timeout</md:display-name>\n                    <md:description xml:lang=\"en\">The maximum timeout allowed by the source.</md:description>\n                </output>\n            </outputs>\n        </exception>\n        <exception item-id=\"9\">\n            <md:code-name>UnknownData</md:code-name>\n            <md:display-name xml:lang=\"en\">Unknown Data</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the source if a request for detailed data is made for an unknown device or property. Requests should only be made to the source from which aggregate data was received and only during a time during which aggregate data was observed.</md:description>\n        </exception>\n        <exception item-id=\"10\">\n            <md:code-name>UnknownSink</md:code-name>\n            <md:display-name xml:lang=\"en\">Unknown Sink</md:display-name>\n            <md:description xml:lang=\"en\">Returned if the sink specified by a request is not known by the source. The request should be retried when the sink is present.</md:description>\n        </exception>\n        <exception item-id=\"11\">\n            <md:code-name>OutOfResource</md:code-name>\n            <md:display-name xml:lang=\"en\">Out of Resource</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the source if it has insufficient resources to persist or process the request. The request may succeed later if additional resources become available.</md:description>\n        </exception>\n        <exception item-id=\"12\">\n            <md:code-name>DuplicateRequestID</md:code-name>\n            <md:display-name xml:lang=\"en\">Duplicate RequestID</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the source if it already has an outstanding request with the specified ID.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:28','2015-09-28 11:59:17',1),(32,'[1:{0100004D}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0100004D}]\">\n    <md:code-name>DATASTOREREQUEST</md:code-name>\n    <md:display-name xml:lang=\"en\">Data Store Request</md:display-name>\n    <md:description xml:lang=\"en\">This interface is used by a sink to request data from a Data Store. Once a request has been accepted, data is delivered to the Sink via a Source.</md:description>\n    <typedefs>\n        <uint32 type-id=\"1\">\n            <md:code-name>RequestID</md:code-name>\n            <md:display-name xml:lang=\"en\">Request ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for a data request, unique to the target sink.</md:description>\n        </uint32>\n        <oid type-id=\"2\">\n            <md:code-name>ID</md:code-name>\n            <md:display-name xml:lang=\"en\">ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for an actor in the data exchange (device, source, sink, parent).</md:description>\n        </oid>\n        <iid type-id=\"3\">\n            <md:code-name>SinkVersion</md:code-name>\n            <md:display-name xml:lang=\"en\">Sink Version</md:display-name>\n            <md:description xml:lang=\"en\">An InterfaceID used to identify the version of information related to the sink InterfaceID associated with this Data Store Source InterfaceID. \n    Future versions of this interface will need to differentiate between versions. All data defined by this interface will begin with this type, allowing it to be read to identify the \n    data format that follows.</md:description>\n        </iid>\n        <blob type-id=\"4\" min-length=\"0\" length=\"1048576\">\n            <md:code-name>DefinitionBlock</md:code-name>\n            <md:display-name xml:lang=\"en\">Definition Block</md:display-name>\n            <md:description xml:lang=\"en\">A compressed block that defines the properties that are being requested. The format of this type is specified by Sink Version and defined by the\n    corresponding interface.</md:description>\n        </blob>\n        <datetime type-id=\"5\">\n            <md:code-name>Timestamp</md:code-name>\n            <md:display-name xml:lang=\"en\">Timestamp</md:display-name>\n            <md:description xml:lang=\"en\">A timestamp.</md:description>\n        </datetime>\n        <uint32 type-id=\"6\">\n            <md:code-name>Milliseconds</md:code-name>\n            <md:display-name xml:lang=\"en\">Milliseconds</md:display-name>\n            <md:description xml:lang=\"en\">A time range in milliseconds.</md:description>\n        </uint32>\n        <structure type-id=\"7\">\n            <md:code-name>Request</md:code-name>\n            <md:display-name xml:lang=\"en\">Request</md:display-name>\n            <md:description xml:lang=\"en\">A request for any data with the specified device identifier, time quantum and any properties included in the definition.</md:description>\n            <field type-ref=\"2\">\n                <md:display-name xml:lang=\"en\">device</md:display-name>\n                <md:description xml:lang=\"en\">The device associated with the data.</md:description>\n            </field>\n            <field type-ref=\"3\">\n                <md:display-name xml:lang=\"en\">Sink Version</md:display-name>\n                <md:description xml:lang=\"en\">The version of the sink storage format, defined as the sink IID that defines the format.</md:description>\n            </field>\n            <field type-ref=\"4\">\n                <md:display-name xml:lang=\"en\">Definition Block</md:display-name>\n                <md:description xml:lang=\"en\">A compressed block that defines the properties that are being requested. The format is defined by the Sink Version IID.</md:description>\n            </field>\n            <field type-ref=\"5\">\n                <md:display-name xml:lang=\"en\">startTime</md:display-name>\n                <md:description xml:lang=\"en\">The inclusive start time of the data to return.</md:description>\n            </field>\n            <field type-ref=\"5\">\n                <md:display-name xml:lang=\"en\">endTime</md:display-name>\n                <md:description xml:lang=\"en\">The exclusive end time of the data to return. Must specify a time after the start time.</md:description>\n            </field>\n            <field type-ref=\"6\">\n                <md:display-name xml:lang=\"en\">quantum</md:display-name>\n                <md:description xml:lang=\"en\">The time interval between stored data points for the requested properties. The requested quantum must exactly match the quantum of the stored data.</md:description>\n            </field>\n        </structure>\n        <uint16 type-id=\"8\" min=\"1\" max=\"1440\">\n            <md:code-name>Minutes</md:code-name>\n            <md:display-name xml:lang=\"en\">Minutes</md:display-name>\n            <md:description xml:lang=\"en\">A time range in minutes, not to exceed one day.</md:description>\n        </uint16>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>RequestData</md:code-name>\n            <md:display-name xml:lang=\"en\">Request Data</md:display-name>\n            <md:description xml:lang=\"en\">Initiate a request for data. All data for the request and notification of its completion will be sent to the indicated sink. \n    If the source is unable retrieve or send requested data for a period of time exceeding maxFailureTime, it will complete the request as Failed and attempt to notify the sink. Likewise,\n    if the target sink does not receive any valuesets containing requested data, or notification of completion, for a period of time exceeding maxFailureTime,\n    it may assume that the request has failed. There is no maximum amount of time that the request may take to complete as long as the source continues to be able\n    to retrieve and send the requested data. This method may throw the No Data, Unknown Sink, Unknown Version, Insufficient Resources, Duplicate RequestID, Out of Range, or Value Set Definition Not Understood exceptions.</md:description>\n            <inputs>\n                <input type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">requestID</md:display-name>\n                    <md:description xml:lang=\"en\">An identifier to associate with this request. The combination of this ID and the sink should be unique.</md:description>\n                </input>\n                <input type-ref=\"2\">\n                    <md:display-name xml:lang=\"en\">sink</md:display-name>\n                    <md:description xml:lang=\"en\">The target sink for the data. This sink follows the distribution rules for sinks, meaning that the request will be load-balanced based on the presence of provider attributes.</md:description>\n                </input>\n                <input type-ref=\"7\">\n                    <md:display-name xml:lang=\"en\">request</md:display-name>\n                    <md:description xml:lang=\"en\">A structure containing information about the request.</md:description>\n                </input>\n                <input type-ref=\"8\">\n                    <md:display-name xml:lang=\"en\">maxFailureTime</md:display-name>\n                    <md:description xml:lang=\"en\">The maximum amount of time that the request may be in an error state, usually due to the inability to either retrieve the requested data or send it to the specified sink.</md:description>\n                </input>\n            </inputs>\n        </method>\n        <method item-id=\"2\">\n            <md:code-name>CancelRequestData</md:code-name>\n            <md:display-name xml:lang=\"en\">Cancel Request Data</md:display-name>\n            <md:description xml:lang=\"en\">Cancel a request for data. The target sink and request ID are provided. This method will return successfully whether or not the request ID is not found, but may throw the Insufficient Resources Exception.</md:description>\n            <inputs>\n                <input type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">requestID</md:display-name>\n                    <md:description xml:lang=\"en\">The identifier associated with this request. The combination of this ID and the sink should be unique.</md:description>\n                </input>\n                <input type-ref=\"2\">\n                    <md:display-name xml:lang=\"en\">sink</md:display-name>\n                    <md:description xml:lang=\"en\">The target sink for the requested data.</md:description>\n                </input>\n            </inputs>\n        </method>\n    </methods>\n    <exceptions>\n        <exception item-id=\"3\">\n            <md:code-name>NoData</md:code-name>\n            <md:display-name xml:lang=\"en\">No Data</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the datastore if it can quickly determine that no data exists for the specified request parameters. If the absence of\n    data cannot be quickly determined then a COMPLETE_NO_DATA request status may instead be sent to the target sink.</md:description>\n        </exception>\n        <exception item-id=\"4\">\n            <md:code-name>UnknownSink</md:code-name>\n            <md:display-name xml:lang=\"en\">Unknown Sink</md:display-name>\n            <md:description xml:lang=\"en\">Returned if the sink specified by a request is not known. The request should be retried when the sink is present.</md:description>\n        </exception>\n        <exception item-id=\"5\">\n            <md:code-name>UnknownVersion</md:code-name>\n            <md:display-name xml:lang=\"en\">Unknown Version</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the datastore if it does not support the sink version specified in a request.</md:description>\n        </exception>\n        <exception item-id=\"6\">\n            <md:code-name>InsufficientResources</md:code-name>\n            <md:display-name xml:lang=\"en\">Insufficient Resources</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the datastore if it has insufficient resources to persist or process the request. The request may succeed later if additional resources become available.</md:description>\n        </exception>\n        <exception item-id=\"7\">\n            <md:code-name>DuplicateRequestID</md:code-name>\n            <md:display-name xml:lang=\"en\">Duplicate RequestID</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the datastore if it already has an outstanding request with the specified ID for the target sink.</md:description>\n        </exception>\n        <exception item-id=\"8\">\n            <md:code-name>ValueSetDefinitionNotUnderstood</md:code-name>\n            <md:display-name xml:lang=\"en\">Value Set Definition Not Understood</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the datastore if the value set definition block is malformed or not understood.</md:description>\n        </exception>\n        <exception item-id=\"9\">\n            <md:code-name>OutOfRange</md:code-name>\n            <md:display-name xml:lang=\"en\">Out of Range</md:display-name>\n            <md:description xml:lang=\"en\">Returned by the datastore if the maxFailureTime is less than 1 or greater than 1440, or if the end time is not after the start time.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:28','2015-09-28 11:59:17',1),(33,'[1:{09}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{09}]\">\n    <md:display-name xml:lang=\"en\">Device Control</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents control over a device that can be powered off and rebooted. All methods will return once the request is accepted and before the request has completed. \'Request Failed\' may be returned as an exception from all of the methods.</md:description>\n    <typedefs>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:display-name xml:lang=\"en\">Shutdown</md:display-name>\n            <md:description xml:lang=\"en\">Request that the device shutdown (power off). Network connectivity will be lost until some other action restarts the device, although a successful response to this method should be received.</md:description>\n        </method>\n        <method item-id=\"2\">\n            <md:display-name xml:lang=\"en\">Reboot</md:display-name>\n            <md:description xml:lang=\"en\">Request that the device reboot (reset hardware and start executing cleanly). Network connectivity will be lost temporarily, although a successful response to this method should be received.</md:description>\n        </method>\n    </methods>\n    <exceptions>\n        <exception item-id=\"3\">\n            <md:display-name xml:lang=\"en\">Request Failed</md:display-name>\n            <md:description xml:lang=\"en\">Returned from any of the methods if the request failed. This does not indicate a permanent failure or the reason for the failure, which may vary by device. Retrying the request at a later time is appropriate. There is no indication of how long is appropriate to wait before attempting the operation again.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:28','2015-09-28 11:59:17',1),(34,'[1:{01}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01}]\">\n    <md:code-name>DEVICE_STATUS_INTERFACE</md:code-name>\n    <md:display-name xml:lang=\"ja\">Status（ステータス）</md:display-name>\n    <md:display-name xml:lang=\"en\">Status</md:display-name>\n    <md:description xml:lang=\"ja\">このインターフェースは機器によって提供され、これによって機器のステータスを確認できる。</md:description>\n    <md:description xml:lang=\"en\">This interface is provided by devices and allows a device\'s status to be retrieved.</md:description>\n    <typedefs>\n        <uint8 type-id=\"0\" min=\"0\" max=\"2\">\n            <md:code-name>StatusType</md:code-name>\n            <md:display-name xml:lang=\"ja\">Status（ステータス）</md:display-name>\n            <md:display-name xml:lang=\"en\">Status</md:display-name>\n            <md:description xml:lang=\"ja\">ステータスの列挙型値：ステータスの値は、OK（0）、WARN（1）、ERROR（2）の3つがある。</md:description>\n            <md:description xml:lang=\"en\">An enumerated value for the status. There are three status values: OK (0), WARN (1), and ERROR (2).</md:description>\n        </uint8>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:code-name>Status</md:code-name>\n            <md:display-name xml:lang=\"ja\">Status（ステータス）</md:display-name>\n            <md:display-name xml:lang=\"en\">Status</md:display-name>\n            <md:description xml:lang=\"ja\">機器のステータス</md:description>\n            <md:description xml:lang=\"en\">The status of the device.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:29','2015-09-28 11:59:18',1),(35,'[1:{01000002}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000002}]\">\n    <md:code-name>IEVENT</md:code-name>\n    <md:display-name xml:lang=\"ja\">トレーニング用イベント</md:display-name>\n    <md:display-name xml:lang=\"en\">Training Event</md:display-name>\n    <md:description xml:lang=\"ja\">\n        このインターフェースは、メソッドとイベントを非常に簡単に実装するための手段を提供する。トレーナー用ベースインターフェイスと併用する場合は、セッションとして提供することが可能である。\n        <![CDATA[<br>\n        <h3>Associated Interfaces</h3>\n   	    <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000000\">Training Base</a></li>\n   	    </ul>]]>\n    </md:description>\n    <md:description xml:lang=\"en\">\n        This interface provides an easy-to-implement method and event. It can be provided as a session if used in conjunction with the Training Base Interface.\n        <![CDATA[<br>\n        <h3>Associated Interfaces</h3>\n   	    <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000000\">Training Base</a></li>\n   	    </ul>]]>\n    </md:description>\n    <typedefs>\n        <uint8 type-id=\"0\">\n            <md:code-name>Seconds</md:code-name>\n            <md:display-name xml:lang=\"ja\">Seconds</md:display-name>\n            <md:display-name xml:lang=\"en\">Seconds</md:display-name>\n            <md:description xml:lang=\"ja\">秒単位の時間。</md:description>\n            <md:description xml:lang=\"en\">A quantity of time in seconds.</md:description>\n        </uint8>\n        <string type-id=\"1\" encoding=\"3\" length=\"32\">\n            <md:code-name>Message</md:code-name>\n            <md:display-name xml:lang=\"ja\">Message</md:display-name>\n            <md:display-name xml:lang=\"en\">Message</md:display-name>\n            <md:description xml:lang=\"ja\">短いASCII文字列。</md:description>\n            <md:description xml:lang=\"en\">A short ASCII string.</md:description>\n        </string>\n    </typedefs>\n    <properties>\n        <property item-id=\"2\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:code-name>Countdown</md:code-name>\n            <md:display-name xml:lang=\"ja\">Countdown</md:display-name>\n            <md:display-name xml:lang=\"en\">Countdown</md:display-name>\n            <md:description xml:lang=\"ja\">この読み取り専用プロパティは、ゼロまでカウントダウンする。</md:description>\n            <md:description xml:lang=\"en\">This read-only property counts down to zero.</md:description>\n        </property>\n        <property item-id=\"3\" type-ref=\"1\" read=\"true\" write=\"true\">\n            <md:code-name>EventText</md:code-name>\n            <md:display-name xml:lang=\"ja\">EventText</md:display-name>\n            <md:display-name xml:lang=\"en\">EventText</md:display-name>\n            <md:description xml:lang=\"ja\">イベントが発生した際に送信されるテキスト文字列。空にすることはできない。このプロパティに空の文字列をセットしようとすると、例外「EventTextInvalid」が出力される。</md:description>\n            <md:description xml:lang=\"en\">This is the text string that is sent when an event occurs. It must not be empty. The EventTextInvalid exception is thrown if you attempt to set this property to an empty string.</md:description>\n        </property>\n    </properties>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>ScheduleEvent</md:code-name>\n            <md:display-name xml:lang=\"ja\">ScheduleEvent</md:display-name>\n            <md:display-name xml:lang=\"en\">ScheduleEvent</md:display-name>\n            <md:description xml:lang=\"ja\">イベントをスケジュールする。このプロバイダ上で現在スケジュールされているすべてのイベントが置き換えられる。EventTextプロパティが空の文字列である場合、このメソッドは例外「EventTextInvalid」を出力する。</md:description>\n            <md:description xml:lang=\"en\">This schedules an event. Any currently scheduled event on this provider is replaced. If the EventText property is an empty string, this method throws the EventTextInvalid exception.</md:description>\n            <inputs>\n                <input type-ref=\"0\">\n                    <md:display-name xml:lang=\"ja\">delay</md:display-name>\n                    <md:display-name xml:lang=\"en\">delay</md:display-name>\n                    <md:description xml:lang=\"ja\">イベントがトリガされるまでの秒数。メソッドによってCountdownプロパティがこの値にセットされる。</md:description>\n                    <md:description xml:lang=\"en\">The number of seconds that should elapse before the event is triggered. The method sets the Countdown property to this value.</md:description>\n                </input>\n            </inputs>\n        </method>\n    </methods>\n    <events>\n        <event item-id=\"4\">\n            <md:code-name>StringEvent</md:code-name>\n            <md:display-name xml:lang=\"ja\">StringEvent</md:display-name>\n            <md:display-name xml:lang=\"en\">StringEvent</md:display-name>\n            <md:description xml:lang=\"ja\">このイベントが発生した場合は、EventTextプロパティがリクエスタに送信される。</md:description>\n            <md:description xml:lang=\"en\">When this event occurs, the EventText property is sent to the requestor.</md:description>\n            <outputs>\n                <output type-ref=\"1\">\n                    <md:display-name xml:lang=\"ja\">str</md:display-name>\n                    <md:display-name xml:lang=\"en\">str</md:display-name>\n                    <md:description xml:lang=\"ja\">EventTextプロパティの現在の値。</md:description>\n                    <md:description xml:lang=\"en\">The current value of the EventText property.</md:description>\n                </output>\n            </outputs>\n        </event>\n    </events>\n    <exceptions>\n        <exception item-id=\"5\">\n            <md:code-name>EventTextInvalid</md:code-name>\n            <md:display-name xml:lang=\"ja\">EventTextInvalid</md:display-name>\n            <md:display-name xml:lang=\"en\">EventTextInvalid</md:display-name>\n            <md:description xml:lang=\"ja\">EventTextプロパティが空の文字列である場合、この例外が出力される。</md:description>\n            <md:description xml:lang=\"en\">This exception is thrown if the EventText property is an empty string.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:29','2015-09-28 11:59:18',1),(36,'[1:{0A}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0A}]\">\n    <md:display-name xml:lang=\"ja\">ローカル制御許可</md:display-name>\n    <md:display-name xml:lang=\"en\">Local Control Enable</md:display-name>\n    <md:description xml:lang=\"ja\">このインターフェースは、機器に対するローカル制御を許可するか不許可にするかの設定機能を提供します。「ローカル制御」とは、通信セキュリティモデルの範囲で制御を制限することができないような手段による制御全般を指します。例えばその機器が持つ物理的なボタンや、その機器を制御するための赤外線リモコンやコントロールパネル、などによる制御を指します。一方で、もしコントロールパネルからの制御をセキュリティモデルで制限できるのであれば、その制御は「ローカル制御」ではありません。また、安全設計の観点や機器の物理構造の制約により禁止することができない「ローカル制御」もあり得ることに注意してください。例えば電源供給を物理的に切断する止めるようなタイプのスイッチによる制御は「ローカル制御」の定義に含まれますが、この制御をこのインターフェースを介して禁止することは期待できません。</md:description>\n    <md:description xml:lang=\"en\">This interface provides the configuration function for enable of device local control.  The term of \"local control\" is means the control operation that cannot be limited by security model of the networking. For example, it is a \"local control\" generally that the control operation using physical button on the device, infrared remote controller, or control panel.  On the other hand, it is not a \"local control\" if the control operation can be limited by security model of the networking.  It should be noted that there may be some \"local control\" of each device that can not be limited using this interface for security reason or the design limitation of the device.  For example, the operation using the physical switch of the device to cut the power supply is a \"local control\" definitely but it cannot be limited by using this interface.</md:description>\n    <typedefs>\n        <boolean type-id=\"0\">\n            <md:display-name xml:lang=\"ja\">Flag</md:display-name>\n            <md:display-name xml:lang=\"en\">Flag</md:display-name>\n            <md:description xml:lang=\"ja\">許可状態を示すフラグ。</md:description>\n            <md:description xml:lang=\"en\">A flag indicates enable.</md:description>\n        </boolean>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"true\">\n            <md:display-name xml:lang=\"ja\">enable flag</md:display-name>\n            <md:display-name xml:lang=\"en\">is enable</md:display-name>\n            <md:description xml:lang=\"ja\">ローカル制御許可フラグ。trueであれば許可。falseであれば不許可。</md:description>\n            <md:description xml:lang=\"en\">The flag indicates local control enable. If this flag is TRUE, local control for the device is enabled.</md:description>\n        </property>\n    </properties>\n    <exceptions>\n        <exception item-id=\"2\">\n            <md:display-name xml:lang=\"ja\">Cannot be enable</md:display-name>\n            <md:display-name xml:lang=\"en\">Cannot be enabled</md:display-name>\n            <md:description xml:lang=\"ja\">何らかの理由で一時的にローカル制御を許可にできないことを示す例外。この例外は\"enable flag\"をtrueに設定しようとした際に発生する可能性がある。</md:description>\n            <md:description xml:lang=\"en\">The exception indicates that the flag cannot be enabled temporarily for some reason (for example to be safety).</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:29','2015-09-28 11:59:18',1),(37,'[1:{08}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{08}]\">\n    <md:display-name xml:lang=\"en\">Program Control</md:display-name>\n    <md:description xml:lang=\"en\">This interface models the type of program control defined by initd on Linux operating systems. This interface can be exposed on any object that exhibits the same type of control (start, stop, restart). All methods may return once the request is accepted and before the state change has completed. \'Request Failed\' may be returned as an exception from all of the methods.</md:description>\n    <typedefs>\n        <uint8 type-id=\"0\" min=\"0\" max=\"3\">\n            <md:display-name xml:lang=\"en\">State</md:display-name>\n            <md:description xml:lang=\"en\">The current state of the program. The following values are valid with the given meanings: (0) STOPPED, (1) STARTING, (2) RUNNING, (3) STOPPING.</md:description>\n        </uint8>\n    </typedefs>\n    <properties>\n        <property item-id=\"0\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Program State</md:display-name>\n            <md:description xml:lang=\"en\">Return the current operating state of the program.</md:description>\n        </property>\n    </properties>\n    <methods>\n        <method item-id=\"1\">\n            <md:display-name xml:lang=\"en\">Start</md:display-name>\n            <md:description xml:lang=\"en\">Instruct the program to start running.</md:description>\n        </method>\n        <method item-id=\"2\">\n            <md:display-name xml:lang=\"en\">Stop</md:display-name>\n            <md:description xml:lang=\"en\">Instruct the program to stop running.</md:description>\n        </method>\n        <method item-id=\"3\">\n            <md:display-name xml:lang=\"en\">Restart</md:display-name>\n            <md:description xml:lang=\"en\">Instruct the program to restart (stop followed by a start).</md:description>\n        </method>\n    </methods>\n    <exceptions>\n        <exception item-id=\"4\">\n            <md:display-name xml:lang=\"en\">Request Failed</md:display-name>\n            <md:description xml:lang=\"en\">Returned from any of the methods if the request failed to initiate or complete the state change as requested. The current state after a failure may not be the same as the state when the request was received and should be verified by reading the current state.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:30','2015-09-28 11:59:18',1),(38,'[1:{0227}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0227}]\">\n    <md:code-name>TOPOLOGYINFO</md:code-name>\n    <md:display-name xml:lang=\"en\">Topology Information</md:display-name>\n    <md:description xml:lang=\"en\">\n        This interface provides bulk topology information useful to \'bootstrap\' a topology index. The provider of this information does not necessarily correspond to a source or a sink. In order to provide some size limitations, the amount of information that can be passed in a single response is limited. If a node has more information than can be provided in a single response, it should use multiple objects. It can use any method to determine which object identifiers it wants to use - the responding object is not important to the requester.\n  	    <![CDATA[<br><h3>Associated Interfaces</h3>\n        <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000022\">Data Manager</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000028\">Data Topology Update</a></li>\n        </ul>]]>\n    </md:description>\n    <typedefs>\n        <oid type-id=\"1\">\n            <md:code-name>ID</md:code-name>\n            <md:display-name xml:lang=\"en\">ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for an actor in the data exchange (device, source, sink, parent).</md:description>\n        </oid>\n        <nullable type-id=\"2\" type-ref=\"1\">\n            <md:code-name>OptionalID</md:code-name>\n            <md:display-name xml:lang=\"en\">Optional ID</md:display-name>\n            <md:description xml:lang=\"en\">An optional ID that is used in cases (for example, parent) where the ID may not exist. NULL indicates that there is no ID.</md:description>\n        </nullable>\n        <uint16 type-id=\"3\">\n            <md:code-name>Position</md:code-name>\n            <md:display-name xml:lang=\"en\">Position</md:display-name>\n            <md:description xml:lang=\"en\">The logical position of the device relative to the parent. The parent defines the context/meaning of the positions for its children. A parent may have multiple children with the same position, which may indicate a grouping or relationship between those children. The position is meta-data associated with the device itself, and not related directly to data or an event.</md:description>\n        </uint16>\n        <nullable type-id=\"4\" type-ref=\"3\">\n            <md:code-name>OptionalPosition</md:code-name>\n            <md:display-name xml:lang=\"en\">Optional Position</md:display-name>\n            <md:description xml:lang=\"en\">An optional position is used in cases where the position may not exist. NULL indicates that there is no position.</md:description>\n        </nullable>\n        <structure type-id=\"5\">\n            <md:code-name>Topology</md:code-name>\n            <md:display-name xml:lang=\"en\">Topology</md:display-name>\n            <md:description xml:lang=\"en\">A structure containing topology information about a node.</md:description>\n            <field type-ref=\"1\">\n                <md:display-name xml:lang=\"en\">id</md:display-name>\n                <md:description xml:lang=\"en\">The ID of the node.</md:description>\n            </field>\n            <field type-ref=\"2\">\n                <md:display-name xml:lang=\"en\">parent</md:display-name>\n                <md:description xml:lang=\"en\">The ID of the parent of the device, if applicable.  The parent is meta-data associated with the device itself, and not related directly to data or an event.</md:description>\n            </field>\n            <field type-ref=\"4\">\n                <md:display-name xml:lang=\"en\">position</md:display-name>\n                <md:description xml:lang=\"en\">The position of the device relative to the parent, if applicable. The position is meta-data associated with the device itself, and not related directly to data or an event.</md:description>\n            </field>\n        </structure>\n        <array type-id=\"6\" type-ref=\"5\" min-length=\"1\" length=\"1000\">\n            <md:code-name>TopologyArray</md:code-name>\n            <md:display-name xml:lang=\"en\">TopologyArray</md:display-name>\n            <md:description xml:lang=\"en\">An array of topology information from a source. If all the information cannot be put in a single array then multiple providers must be created.</md:description>\n        </array>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>GetTopologyInfo</md:code-name>\n            <md:display-name xml:lang=\"en\">Get Topology Info</md:display-name>\n            <md:description xml:lang=\"en\">Returns an array of topology info from a source. If a source has more topology info than will fit in the array then multiple providers are required.</md:description>\n            <inputs>\n                <input type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">node</md:display-name>\n                    <md:description xml:lang=\"en\">An ID to specify the desired result set. The broadcast OID indicates that all information should be returned. If a specific ID is used, then only information about that ID should be included. In this case no response would be generated by nodes that do not have relevant information.</md:description>\n                </input>\n            </inputs>\n            <outputs>\n                <output type-ref=\"1\">\n                    <md:display-name xml:lang=\"en\">source</md:display-name>\n                    <md:description xml:lang=\"en\">The ID of the source that manages the devices.</md:description>\n                </output>\n                <output type-ref=\"6\">\n                    <md:display-name xml:lang=\"en\">topologyInfo</md:display-name>\n                    <md:description xml:lang=\"en\">An array of topology information related to the source.</md:description>\n                </output>\n            </outputs>\n        </method>\n    </methods>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:30','2015-09-28 11:59:19',1),(39,'[1:{01000028}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000028}]\">\n    <md:code-name>TOPOLOGYUPDATE</md:code-name>\n    <md:display-name xml:lang=\"en\">Topology Update</md:display-name>\n    <md:description xml:lang=\"en\">\n        This interface is used to notify a provider about topology changes. Topology information is typically updated as data is delivered. However, there are cases where it is desirable to simply be notified of topology changes. This interface implies the requestor maintains state of the topology, thus knowning the previous state of the device in addition to the updated state.\n  	    <![CDATA[<br><h3>Associated Interfaces</h3>\n        <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000022\">Data Manager</a></li>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.0227\">Topology Info</a></li>\n        </ul>]]>\n    </md:description>\n    <typedefs>\n        <oid type-id=\"0\">\n            <md:code-name>ID</md:code-name>\n            <md:display-name xml:lang=\"en\">ID</md:display-name>\n            <md:description xml:lang=\"en\">An identifier for an actor in the data exchange (device, source, sink, parent).</md:description>\n        </oid>\n        <nullable type-id=\"1\" type-ref=\"0\">\n            <md:code-name>OptionalID</md:code-name>\n            <md:display-name xml:lang=\"en\">Optional ID</md:display-name>\n            <md:description xml:lang=\"en\">An optional ID that is used in cases (for example, parent) where the ID may not exist. NULL indicates that there is no ID.</md:description>\n        </nullable>\n        <datetime type-id=\"2\">\n            <md:code-name>Timestamp</md:code-name>\n            <md:display-name xml:lang=\"en\">Timestamp</md:display-name>\n            <md:description xml:lang=\"en\">The time at which the topology change occurred.</md:description>\n        </datetime>\n        <uint16 type-id=\"3\">\n            <md:code-name>Position</md:code-name>\n            <md:display-name xml:lang=\"en\">Position</md:display-name>\n            <md:description xml:lang=\"en\">The logical position of the device relative to the parent. The parent defines the context/meaning of the positions for its children. A parent may have multiple children with the same position, which may indicate a grouping or relationship between those children. The position is meta-data associated with the device itself, and not related directly to data or an event.</md:description>\n        </uint16>\n        <nullable type-id=\"4\" type-ref=\"2\">\n            <md:code-name>OptionalPosition</md:code-name>\n            <md:display-name xml:lang=\"en\">Optional Position</md:display-name>\n            <md:description xml:lang=\"en\">An optional position is used in cases where the position may not exist. NULL indicates that there is no position.</md:description>\n        </nullable>\n    </typedefs>\n    <methods>\n        <method item-id=\"1\">\n            <md:code-name>parentChanged</md:code-name>\n            <md:display-name xml:lang=\"en\">Parent Changed</md:display-name>\n            <md:description xml:lang=\"en\">Send notification that the parent of the device has changed.</md:description>\n            <inputs>\n                <input type-ref=\"0\">\n                    <md:code-name>device</md:code-name>\n                    <md:display-name xml:lang=\"en\">device</md:display-name>\n                    <md:description xml:lang=\"en\">The device for which the parent has changed.</md:description>\n                </input>\n                <input type-ref=\"2\">\n                    <md:code-name>timestamp</md:code-name>\n                    <md:display-name xml:lang=\"en\">timestamp</md:display-name>\n                    <md:description xml:lang=\"en\">The time at which the parent changed.</md:description>\n                </input>\n                <input type-ref=\"1\">\n                    <md:code-name>original</md:code-name>\n                    <md:display-name xml:lang=\"en\">original</md:display-name>\n                    <md:description xml:lang=\"en\">The original (old) parent of the device.</md:description>\n                </input>\n                <input type-ref=\"1\">\n                    <md:code-name>update</md:code-name>\n                    <md:display-name xml:lang=\"en\">update</md:display-name>\n                    <md:description xml:lang=\"en\">The updated (new) parent of the device.</md:description>\n                </input>\n            </inputs>\n        </method>\n        <method item-id=\"2\">\n            <md:code-name>positionChanged</md:code-name>\n            <md:display-name xml:lang=\"en\">Position Changed</md:display-name>\n            <md:description xml:lang=\"en\">Send notification that the position of the device has changed.</md:description>\n            <inputs>\n                <input type-ref=\"0\">\n                    <md:code-name>device</md:code-name>\n                    <md:display-name xml:lang=\"en\">device</md:display-name>\n                    <md:description xml:lang=\"en\">The device for which the position has changed.</md:description>\n                </input>\n                <input type-ref=\"2\">\n                    <md:code-name>timestamp</md:code-name>\n                    <md:display-name xml:lang=\"en\">timestamp</md:display-name>\n                    <md:description xml:lang=\"en\">The time at which the position changed.</md:description>\n                </input>\n                <input type-ref=\"4\">\n                    <md:code-name>original</md:code-name>\n                    <md:display-name xml:lang=\"en\">original</md:display-name>\n                    <md:description xml:lang=\"en\">The original (old) position of the device.</md:description>\n                </input>\n                <input type-ref=\"4\">\n                    <md:code-name>update</md:code-name>\n                    <md:display-name xml:lang=\"en\">update</md:display-name>\n                    <md:description xml:lang=\"en\">The updated (new) position of the device.</md:description>\n                </input>\n            </inputs>\n        </method>\n    </methods>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:30','2015-09-28 11:59:19',1),(40,'[1:{0B}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0B}]\">\n    <md:display-name xml:lang=\"ja\">総稼働時間</md:display-name>\n    <md:display-name xml:lang=\"en\">Total operation time</md:display-name>\n    <md:description xml:lang=\"ja\">このインターフェースは、現在までの機器の総稼働時間情報を提供します。</md:description>\n    <md:description xml:lang=\"en\">This interface provides the total operation time of the device itself.</md:description>\n    <typedefs>\n        <uint64 type-id=\"0\">\n            <md:display-name xml:lang=\"ja\">Seconds</md:display-name>\n            <md:display-name xml:lang=\"en\">Seconds</md:display-name>\n            <md:description xml:lang=\"ja\">秒数。</md:description>\n            <md:description xml:lang=\"en\">Seconds.</md:description>\n        </uint64>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"ja\">総稼働時間</md:display-name>\n            <md:display-name xml:lang=\"en\">total operation time</md:display-name>\n            <md:description xml:lang=\"ja\">現在までの機器の総稼働時間。この値は単調に累積される値であり、減少することやリセットされることはない。なお、稼働時間とは単に機器が生産されてからの経過時間ではなく、機器の電源スイッチがONになっている時間を意味する。</md:description>\n            <md:description xml:lang=\"en\">The total operation time of the device. This value is cumulative over the lifetime of the device.  This value cannot be decreased and cannot be reset also. In addition, the meaning of the term of \"operation time\" is the time that power switch of the device is turned ON.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:30','2015-09-28 11:59:19',1),(41,'[1:{0100000A}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0100000A}]\">\n    <md:code-name>TRANSPORT_DEMO</md:code-name>\n    <md:display-name xml:lang=\"ja\">通信デモンストレーション用インタフェース</md:display-name>\n    <md:display-name xml:lang=\"en\">Transport Demo Interface</md:display-name>\n    <md:description xml:lang=\"ja\">低速DLC，IEEE802.15.4や，LEDを搭載する仮想機器もしくは仮想LED表示器により構成される「通信デモキット」にて，このインタフェースを用います．</md:description>\n    <md:description xml:lang=\"en\">This interface is associated with the Transport Demonstration Kit, which includes LoDLC, 802.15.4, and virtual devices that have LED or virtual LED indicators.</md:description>\n    <typedefs>\n        <uint8 type-id=\"0\">\n            <md:code-name>LED</md:code-name>\n            <md:display-name xml:lang=\"ja\">LED</md:display-name>\n            <md:display-name xml:lang=\"en\">LED</md:display-name>\n            <md:description xml:lang=\"ja\">LEDの状態として定義されます．値が0のとき消灯状態で，255のとき最大出力点灯状態です．明るさ制御を実現するLED回路を持つ場合は，線形補間された明るさで中間値を実装する必要があります．一方で，明るさ制御を実現する回路を持たない機器の場合は，0より大きい値は，最大出力点灯状態として取り扱う必要があります．</md:description>\n            <md:description xml:lang=\"en\">Defines the state of an LED. 0=off. 255=fully on. Intermediate values must be implemented in a logical linear fashion for LED circuits that support variable brightnesses. Devices that have LED circuits that do not support variable brightnesses must treat all values greater than 0 as fully on.</md:description>\n        </uint8>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"true\">\n            <md:code-name>LEDState</md:code-name>\n            <md:display-name xml:lang=\"ja\">LED 状態</md:display-name>\n            <md:display-name xml:lang=\"en\">LED State</md:display-name>\n            <md:description xml:lang=\"ja\">機器上のLED状態．</md:description>\n            <md:description xml:lang=\"en\">The state of the LED on a device.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:31','2015-09-28 11:59:19',1),(42,'[1:{01000001}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000001}]\">\n    <md:code-name>IWAVEFORM</md:code-name>\n    <md:display-name xml:lang=\"ja\">トレーニング用波形インターフェース</md:display-name>\n    <md:display-name xml:lang=\"en\">Training Waveform Interface</md:display-name>\n    <md:description xml:lang=\"ja\">\n        このインターフェースは、プロパティを非常に簡単に実装するための手段を提供する。トレーナー用ベースインターフェイスと併用する場合は、セッションとして提供することが可能である。\n        <![CDATA[<br>\n        <h3>Associated Interfaces</h3>\n   	    <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000000\">Training Base</a></li>\n   	    </ul>]]>\n</md:description>\n    <md:description xml:lang=\"en\">\n        This interface provides easy-to-implement properties. It can be provided as a session if used in conjunction with the Training Base Interface.\n        <![CDATA[<br>\n        <h3>Associated Interfaces</h3>\n   	    <ul>\n            <li><a href=\"https://interface.opendof.org/interface-repository/interface?cmd=GetInterface&trans=html&iid=dof/1.01000000\">Training Base</a></li>\n   	    </ul>]]>\n    </md:description>\n    <typedefs>\n        <uint8 type-id=\"0\">\n            <md:code-name>Value</md:code-name>\n            <md:display-name xml:lang=\"ja\">Value</md:display-name>\n            <md:display-name xml:lang=\"en\">Value</md:display-name>\n            <md:description xml:lang=\"ja\">波の値です。単位のないこの番号。</md:description>\n            <md:description xml:lang=\"en\">A value of the wave. This a number without units.</md:description>\n        </uint8>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:code-name>Position</md:code-name>\n            <md:display-name xml:lang=\"ja\">Position</md:display-name>\n            <md:display-name xml:lang=\"en\">Position</md:display-name>\n            <md:description xml:lang=\"ja\">波形の現在の位置。この位置は、MinimumプロパティとMaximumプロパティとの間を移動する。</md:description>\n            <md:description xml:lang=\"en\">The current value of the waveform, which will change between the Minimum property and the Maximum property.</md:description>\n        </property>\n        <property item-id=\"2\" type-ref=\"0\" read=\"true\" write=\"true\">\n            <md:code-name>Minimum</md:code-name>\n            <md:display-name xml:lang=\"ja\">Minimum</md:display-name>\n            <md:display-name xml:lang=\"en\">Minimum</md:display-name>\n            <md:description xml:lang=\"ja\">波形の最小振幅。この数値は、Maximumプロパティ以下でなければならない。</md:description>\n            <md:description xml:lang=\"en\">The minimum amplitude of the waveform. It must be less than or equal to the Maximum property.</md:description>\n        </property>\n        <property item-id=\"3\" type-ref=\"0\" read=\"true\" write=\"true\">\n            <md:code-name>Maximum</md:code-name>\n            <md:display-name xml:lang=\"ja\">Maximum</md:display-name>\n            <md:display-name xml:lang=\"en\">Maximum</md:display-name>\n            <md:description xml:lang=\"ja\">波形の最大振幅。この数値は、Minimumプロパティ以上でなければならない。</md:description>\n            <md:description xml:lang=\"en\">The maximum amplitude of the waveform. It must be greater than or equal to the Minimum property.</md:description>\n        </property>\n    </properties>\n    <exceptions>\n        <exception item-id=\"4\">\n            <md:code-name>InvalidMinMax</md:code-name>\n            <md:display-name xml:lang=\"ja\">Invalid Min/Max</md:display-name>\n            <md:display-name xml:lang=\"en\">Invalid Min/Max</md:display-name>\n            <md:description xml:lang=\"ja\">リクエスタが無効なMinimum プロパティまたは Maximumプロパティをセットしようとした場合に出力される例外。</md:description>\n            <md:description xml:lang=\"en\">This is thrown if a requestor attempts to set an invalid Minimum or Maximum property.</md:description>\n        </exception>\n    </exceptions>\n</interface>\n','1','opendof',10,'2015-09-28 11:47:31','2015-09-28 11:59:19',1),(43,'[1:{01000024}]','<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[01:{01000024}]\">\n	<md:code-name>DEW_POINT_TEMPERATURE_INTERFACE</md:code-name>\n	<md:display-name xml:lang=\"en\">Dew Point Temperature</md:display-name>\n	<md:description xml:lang=\"en\">\n		This interface is used to record the dew point temperature of a weather station.\n	</md:description>\n		<typedefs>\n			<float32 type-id=\"0\">\n				<md:code-name>Temperature</md:code-name>\n				<md:display-name xml:lang=\"en\">Temperature</md:display-name>\n				<md:description xml:lang=\"en\">\n					A measure of temperature.\n				</md:description>\n				<unit>Celsius</unit>\n			</float32>\n		</typedefs>\n	<properties>\n		<property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n			<md:code-name>dewPointTemperature</md:code-name>\n			<md:display-name xml:lang=\"en\">Dew Point Temperature</md:display-name>\n			<md:description xml:lang=\"en\">The dew point temperature.</md:description>\n		</property>\n	</properties>\n</interface>\n','1','opendof',10,'2015-10-01 15:23:46','2015-10-01 15:23:46',0),(44,'[1:{01000025}]','<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[01:{01000025}]\">\n	<md:code-name>DRY_BULB_TEMPERATURE_INTERFACE</md:code-name>\n	<md:display-name xml:lang=\"en\">Dry Bulb Temperature</md:display-name>\n	<md:description xml:lang=\"en\">\n		This interface is used to record the dry bulb temperature of a weather station.\n	</md:description>\n		<typedefs>\n			<float32 type-id=\"0\">\n				<md:code-name>Temperature</md:code-name>\n				<md:display-name xml:lang=\"en\">Temperature</md:display-name>\n				<md:description xml:lang=\"en\">\n					A measure of temperature.\n				</md:description>\n				<unit>Celsius</unit>\n			</float32>\n		</typedefs>\n	<properties>\n		<property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n			<md:code-name>dryBulbTemperature</md:code-name>\n			<md:display-name xml:lang=\"en\">Dry Bulb Temperature</md:display-name>\n			<md:description xml:lang=\"en\">The dry bulb temperature.</md:description>\n		</property>\n	</properties>\n</interface>\n','1','opendof',10,'2015-10-01 15:23:46','2015-10-01 15:23:46',0),(45,'[1:{0100002E}]','<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[01:{0100002E}]\">\n	<md:code-name>POWER_READING_INTERFACE</md:code-name>\n	<md:display-name xml:lang=\"en\">Power Reading</md:display-name>\n	<md:description xml:lang=\"en\">\n		This interface is used to record the power readings for a home.\n	</md:description>\n		<typedefs>\n			<float32 type-id=\"0\">\n				<md:code-name>ApparentPower</md:code-name>\n				<md:display-name xml:lang=\"en\">Apparent Power</md:display-name>\n				<md:description xml:lang=\"en\">\n					A measure of apparent power.\n				</md:description>\n				<unit>Volt-Amperes</unit>\n			</float32>\n		</typedefs>\n	<properties>\n		<property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n			<md:code-name>powerReading</md:code-name>\n			<md:display-name xml:lang=\"en\">Power Reading</md:display-name>\n			<md:description xml:lang=\"en\">The power reading of a single channel.</md:description>\n		</property>\n	</properties>\n</interface>\n','1','opendof',10,'2015-10-01 15:23:46','2015-10-01 15:23:46',0),(46,'[1:{01000026}]','<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[01:{01000026}]\">\n	<md:code-name>WET_BULB_TEMPERATURE_INTERFACE</md:code-name>\n	<md:display-name xml:lang=\"en\">Wet Bulb Temperature</md:display-name>\n	<md:description xml:lang=\"en\">\n		This interface is used to record the wet bulb temperature.\n	</md:description>\n		<typedefs>\n			<float32 type-id=\"0\">\n				<md:code-name>Temperature</md:code-name>\n				<md:display-name xml:lang=\"en\">Temperature</md:display-name>\n				<md:description xml:lang=\"en\">\n					A measure of temperature.\n				</md:description>\n				<unit>Celsius</unit>\n			</float32>\n		</typedefs>\n	<properties>\n		<property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n			<md:code-name>wetBulbTemperature</md:code-name>\n			<md:display-name xml:lang=\"en\">Wet Bulb Temperature</md:display-name>\n			<md:description xml:lang=\"en\">The wet bulb temperature.</md:description>\n		</property>\n	</properties>\n</interface>\n','1','opendof',10,'2015-10-01 15:23:46','2015-10-01 15:23:46',0),(47,'[1:{023A}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{023A}]\">\n    <md:code-name>Pressure</md:code-name>\n    <md:display-name xml:lang=\"en\">Pressure</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents the atmospheric pressure properties of the BaseMeteorological model in the SunSpec Alliance Specification.</md:description>\n    <typedefs>\n        <uint16 type-id=\"1\">\n            <md:code-name>Pressure</md:code-name>\n            <md:display-name xml:lang=\"en\">Pressure</md:display-name>\n            <md:description xml:lang=\"en\">A measurement of pressure.</md:description>\n            <unit>Hectopascals (hPa).</unit>\n        </uint16>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"1\" read=\"true\" write=\"false\">\n            <md:code-name>baroPressure</md:code-name>\n            <md:display-name xml:lang=\"en\">barPressure</md:display-name>\n            <md:description xml:lang=\"en\">The atmospheric (barometric) pressure.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2015-10-07 15:56:17','2016-03-21 20:49:15',0),(48,'[1:{023B}]','<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{023B}]\">\n	<md:code-name>WIND_INTERFACE</md:code-name>\n	<md:display-name xml:lang=\"en\">Wind</md:display-name>\n	<md:description xml:lang=\"en\">\n		This interface is used to record wind.\n	</md:description>\n		<typedefs>\n			<float32 type-id=\"0\">\n				<md:code-name>Speed</md:code-name>\n				<md:display-name xml:lang=\"en\">Speed</md:display-name>\n				<md:description xml:lang=\"en\">\n					A measure of speed.\n				</md:description>\n				<unit>meters per second(m/s)</unit>\n			</float32>\n			<int16 type-id=\"1\" min=\"-179\" max=\"180\">\n				<md:code-name>Direction</md:code-name>\n				<md:display-name xml:lang=\"en\">Temperature</md:display-name>\n				<md:description xml:lang=\"en\">\n					A measure of direction.\n				</md:description>\n				<unit>Degrees (°) east of north. Negative values represent degrees west of North. A value of 0° represents due north and 180° equals due south.</unit>\n			</int16>\n		</typedefs>\n	<properties>\n		<property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n			<md:code-name>windSpeed</md:code-name>\n			<md:display-name xml:lang=\"en\">Wind Speed</md:display-name>\n			<md:description xml:lang=\"en\">The wind speed.</md:description>\n		</property>\n		<property item-id=\"2\" type-ref=\"1\" read=\"true\" write=\"false\">\n			<md:code-name>windDirection</md:code-name>\n			<md:display-name xml:lang=\"en\">Wind Direction</md:display-name>\n			<md:description xml:lang=\"en\">The wind direction.</md:description>\n		</property>\n	</properties>\n</interface>\n','1','opendof',10,'2015-10-07 15:57:08','2015-10-07 15:57:08',0),(49,'[1:{01000056}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000056}]\">\n    <md:code-name>Light</md:code-name>\n    <md:display-name xml:lang=\"en\">Light</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents any device that can produce light.</md:description>\n    <typedefs>\n        <uint8 type-id=\"0\" min=\"0\" max=\"100\">\n            <md:code-name>Brightness</md:code-name>\n            <md:display-name xml:lang=\"en\">Brightness</md:display-name>\n            <md:description xml:lang=\"en\">The brightness of the produced light, as a percentage of maximum. 0 indicates no light (off), 100 indicates maximum brightness.</md:description>\n        </uint8>\n    </typedefs>\n    <properties>\n        <property item-id=\"0\" type-ref=\"0\" read=\"true\" write=\"true\">\n            <md:code-name>brightness</md:code-name>\n            <md:display-name xml:lang=\"en\">Brightness</md:display-name>\n            <md:description xml:lang=\"en\">This is the current brightness output by the device. When setting this value on lights with limited (or no) ability to produce partial/dimmed light, the resulting value will be quantized to the ceiling of the next highest light percentage. For example, a light that has only 3 \npossible outputs (off/half-on/full-on) would have valid values of 0, 50, and 100. 0 will always turn off the light. Any value of 1-50 would be quantized to 50, and any value 51-100 would be quantized to 100.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2015-10-14 13:13:36','2015-10-14 13:13:36',0),(50,'[1:{01000055}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!-- \n	version required immutable\n	iid required immutable\n	all elements are sequence and must be in the order shown here\n	all \"metablocks\" are optional and if given are as follows:\n		code-name elements are required and mutable.  Only one\n		semantics elements are required and mutable. Only one\n		display-name and description are optional and mutable\n		multiple display-name and descriptions can be given, but only one per language\n-->\n<interface \n    xmlns=\"http://opendof.org/schema/interface-repository\" \n    xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" \n    xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" \n    xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd\" \n    iid=\"[01:{01000055}]\">\n	<!-- code-name required mutable, only one -->\n	<md:code-name>cn_Full_Interface</md:code-name>\n	<!-- display-name optional mutable, one per language-->\n	<md:display-name xml:lang=\"en\">dn_Full Interface</md:display-name>\n	<md:display-name xml:lang=\"ja\">エアコンディショナーの状態．</md:display-name>\n	<!-- description optional mutable, one per language-->\n	<md:description xml:lang=\"en\">desc_A test interface with one of everything</md:description>\n	<md:description xml:lang=\"ja\">エアコンディショナーの状態．</md:description>\n	<!-- \n			typedefs optional\n		-->\n	<!-- zero to many typedef \n				for all typedef within typedefs\n					typeid is required, immutable and must be unique within typedefs\n				for all dof types within typedef\'s \n					min and max ranging is optional on all numerical types.\n			-->\n	<typedefs>\n		<!-- encoding, length required and immutable -->\n		<string type-id=\"0\" encoding=\"3\" length=\"256\">\n			<md:code-name>cn_string</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_string</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_文字列</md:display-name>\n			<md:description xml:lang=\"en\">desc_String Type</md:description>\n			<md:description xml:lang=\"ja\">DESC -文字列型</md:description>\n		</string>\n		<boolean type-id=\"1\">\n			<md:code-name>cn_boolean</md:code-name>\n			<md:known-value value=\"true\" xml:lang=\"en\">kv_on</md:known-value>\n			<md:known-value value=\"false\" xml:lang=\"en\">kv_off</md:known-value>\n			<md:known-value value=\"true\" xml:lang=\"ja\">KV1-ブール</md:known-value>\n			<md:known-value value=\"false\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_boolean</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Boolean Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</boolean>\n		<uint8 type-id=\"2\" min=\"1\" max=\"10\">\n			<md:code-name>cn_uint8</md:code-name>\n			<md:known-value value=\"2\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_unit8</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_UInt8 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>miles</unit>\n		</uint8>\n		<uint16 type-id=\"3\" min=\"1\" max=\"10\">\n			<md:code-name>cn_uint16</md:code-name>\n			<md:known-value value=\"2\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_uint16</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Uint16 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>yards</unit>\n		</uint16>\n		<uint32 type-id=\"4\" min=\"1\" max=\"10\">\n			<md:code-name>cn_uint32</md:code-name>\n			<md:known-value value=\"2\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_uint32</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Uint32 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>feet</unit>\n		</uint32>\n		<uint64 type-id=\"5\" min=\"1\" max=\"10\">\n			<md:code-name>cn_uint64</md:code-name>\n			<md:known-value value=\"2\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_uint64</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Uint64 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>inches</unit>\n		</uint64>\n		<int8 type-id=\"6\" min=\"1\" max=\"10\">\n			<md:code-name>cn_int8</md:code-name>\n			<md:known-value value=\"2\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_int8</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Int8 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>miles</unit>\n		</int8>\n		<int16 type-id=\"7\" min=\"1\" max=\"10\">\n			<md:code-name>cn_int16</md:code-name>\n			<md:known-value value=\"2\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_int16</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Int16 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>yards</unit>\n		</int16>\n		<int32 type-id=\"8\" min=\"1\" max=\"10\">\n			<md:code-name>cn_int32</md:code-name>\n			<md:known-value value=\"2\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_int32</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Int32 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>feet</unit>\n		</int32>\n		<int64 type-id=\"9\" min=\"1\" max=\"10\">\n			<md:code-name>cn_int64</md:code-name>\n			<md:known-value value=\"2\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_int64</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Int64 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>inches</unit>\n		</int64>\n		<float32 type-id=\"10\" min=\"1.0\" max=\"10.0\">\n			<md:code-name>cn_float32</md:code-name>\n			<md:known-value value=\"2.0\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4.0\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6.0\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2.0\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4.0\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6.0\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_float32</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_float32 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>inches</unit>\n		</float32>\n		<float64 type-id=\"11\" min=\"1.0\" max=\"10.0\">\n			<md:code-name>cn_float64</md:code-name>\n			<md:known-value value=\"2.0\" xml:lang=\"en\">kv_one</md:known-value>\n			<md:known-value value=\"4.0\" xml:lang=\"en\">kv_two</md:known-value>\n			<md:known-value value=\"6.0\" xml:lang=\"en\">kv_three</md:known-value>\n			<md:known-value value=\"2.0\" xml:lang=\"ja\">VK1ブール</md:known-value>\n			<md:known-value value=\"4.0\" xml:lang=\"ja\">KV2_ブール</md:known-value>\n			<md:known-value value=\"6.0\" xml:lang=\"ja\">KV3_ブール</md:known-value>\n			<md:display-name xml:lang=\"en\">dn_float64</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_float64 Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<unit>inches</unit>\n		</float64>\n		<datetime type-id=\"12\">\n			<md:code-name>cn_datetime</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_datetime</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Datetime Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</datetime>\n		<!-- \n			min-length optional, length required, both immutable, min set to length if not given \n			typeref is required and immutable.  The typeref values must match a typedef ids in this typedefs block \n		-->\n		<array type-id=\"13\"  type-ref=\"0\" min-length=\"3\" length=\"10\">\n				<md:code-name>cn_stringarray</md:code-name>\n				<md:display-name xml:lang=\"en\">dn_stringarray</md:display-name>\n				<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n				<md:description xml:lang=\"en\">desc_Array of String Type</md:description>\n				<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</array>\n		<structure type-id=\"15\">\n			<md:code-name>cn_structure</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_structure</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Structure Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<!-- one to many field\'s required.  The number of field\'s and their values are immutable.  The type-ref values must match a typedef ids in this typedefs block -->\n			<field type-ref=\"18\">\n				<md:code-name>cn_selfReference</md:code-name>\n				<md:display-name xml:lang=\"en\">dn_selfReference</md:display-name>\n				<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n				<md:description xml:lang=\"en\">desc_Nullable Self Reference</md:description>\n				<md:description xml:lang=\"ja\">DESC - NULL可能セルフリファレンス</md:description>\n			</field >\n			<field  type-ref=\"0\">\n				<md:code-name>cn_firstName</md:code-name>\n				<md:display-name xml:lang=\"en\">dn_firstName</md:display-name>\n				<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n				<md:description xml:lang=\"en\">desc_The First Name</md:description>\n				<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			</field >\n			<field  type-ref=\"1\">\n				<md:code-name>cn_qualified</md:code-name>\n				<md:display-name xml:lang=\"en\">dn_qualified</md:display-name>\n				<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n				<md:description xml:lang=\"en\">desc_Boolean, is firstName qualidfied</md:description>\n				<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			</field >\n			<field  type-ref=\"2\">\n				<md:code-name>cn_age</md:code-name>\n				<md:display-name xml:lang=\"en\">dn_age</md:display-name>\n				<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n				<md:description xml:lang=\"en\">desc_Age of firstname</md:description>\n				<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			</field >\n		</structure>\n		<uuid type-id=\"16\">\n			<md:code-name>cn_guid</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_guid</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Guid Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</uuid>\n		<!-- min-length optional, length required, both immutable, min set to length if not given -->\n		<blob type-id=\"17\" min-length=\"3\" length=\"10\">\n			<md:code-name>cn_blob</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_blob</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Blob Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</blob>\n			<!-- type-ref is required and immutable.  It must match a typedef id in this typedefs block -->\n		<nullable type-id=\"18\"  type-ref=\"15\">\n			<md:code-name>cn_nullableStructPointer</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_nullableStructPointer</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Nullable Structure Pointer Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</nullable>\n		<oid type-id=\"19\">\n			<md:code-name>cn_oid</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_oid</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Oid Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</oid>\n		<iid type-id=\"20\">\n			<md:code-name>cn_iid</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_iid</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Iid Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</iid>\n		<nullable type-id=\"21\"  type-ref=\"0\">\n			<md:code-name>cn_nullableStringPointer</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_nullableStringPointer</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Nullable String Pointer Type</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</nullable>\n	</typedefs>\n	<!-- \n			properties optional\n		-->\n	<properties>\n		<!-- \n				zero to many properties \n				itemid required immutable and must be unique within interfaces\n				read, write required and immutable\n				type-ref ref must match a typedef id from the typedefs section\n			-->\n		<property item-id=\"0\" type-ref= \"0\" read=\"true\" write=\"true\">\n				<md:code-name>cn_stringProperty</md:code-name>\n				<md:display-name xml:lang=\"en\">dn_stringProperty</md:display-name>\n				<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n				<md:description xml:lang=\"en\">desc_String Property</md:description>\n				<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</property>\n		<property item-id=\"1\" type-ref= \"1\" read=\"true\" write=\"true\">\n				<md:code-name>cn_booleanProperty</md:code-name>\n				<md:display-name xml:lang=\"en\">dn_booleanProperty</md:display-name>\n				<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n				<md:description xml:lang=\"en\">desc_Boolean Property</md:description>\n				<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</property>\n	</properties>\n	<!-- \n			methods optional\n		-->\n	<methods>\n		<!-- \n				zero to many methods \n				itemid required immutable and must be unique within interfaces\n				all type-ref ref\'s must match a typedef id from the typedefs section\n			-->\n		<method item-id=\"2\">\n			<md:code-name>cn_method1</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_method1</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Method 1</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<!-- inputs optional -->\n			<inputs>\n				<!-- zero to many input type-ref\'s, each could have metablocks -->\n				<input type-ref=\"2\">\n					<md:code-name>cn_m1i1-age</md:code-name>\n					<md:display-name xml:lang=\"en\">dn_m1i1-age</md:display-name>\n					<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n					<md:description xml:lang=\"en\">desc_Method1\' first input parameter which is of type Uint8</md:description>\n					<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n				</input>\n				<input type-ref=\"3\"/>\n				<input type-ref=\"4\"/>\n			</inputs>\n			<!-- outputs optional -->\n			<outputs>\n				<!-- zero to many output type-ref\'s, each could have metablocks -->\n				<output type-ref=\"5\"/>\n				<output type-ref=\"6\">\n					<md:code-name>cn_m1o2-age</md:code-name>\n					<md:display-name xml:lang=\"en\">dn_m1o2-age</md:display-name>\n					<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n					<md:description xml:lang=\"en\">desc_Method1\' second output parameter which is of type Int8</md:description>\n					<md:description xml:lang=\"ja\">タイプのINT8あるDESC -方法1 「第二の出力パラメータ</md:description>\n				</output>\n				<output type-ref=\"7\"/>\n			</outputs>\n		</method>\n		<method item-id=\"8\">\n			<md:code-name>cn_method2</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_method2</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_method 2</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<inputs>\n				<input type-ref=\"9\"/>\n				<input type-ref=\"10\"/>\n				<input type-ref=\"11\"/>\n			</inputs>\n			<outputs>\n				<output type-ref=\"12\"/>\n				<output type-ref=\"13\"/>\n				<output type-ref=\"15\"/>\n			</outputs>\n		</method>\n	</methods>\n	<!-- \n			events required \n		-->\n	<events>\n		<!-- \n				zero to many events \n				itemid required immutable and must be unique within interfaces\n				all typeref ref\'s must match a typedef id from the typedefs section\n			-->\n		<event item-id=\"4\">\n			<md:code-name>cn_event1</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_event1</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Event 1</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<!-- outputs optional -->\n			<outputs>\n				<!-- zero to many output typeref\'s, each typeref could have a metablock  -->\n				<output type-ref=\"15\">\n					<md:code-name>cn_event1o1</md:code-name>\n					<md:display-name xml:lang=\"en\">dn_event1o1</md:display-name>\n					<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n					<md:description xml:lang=\"en\">desc_Event 1\'s output 1 which is our structure</md:description>\n					<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n				</output>\n				<output type-ref=\"16\"/>\n				<output type-ref=\"17\"/>\n			</outputs>\n		</event>\n		<event item-id=\"5\">\n			<md:code-name>cn_event2</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_event2</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Event 2</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n		</event>\n	</events>\n	<!-- \n			exceptions optional \n		-->\n	<exceptions>\n		<!-- \n				zero to many exceptions \n				item-id required immutable and must be unique within interfaces\n			-->\n		<exception item-id=\"6\">\n			<md:code-name>cn_exception1</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_exception1</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_Exception 1</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<!-- outputs optional -->\n			<outputs>\n				<!-- zero to many output typeref\'s, each typeref could have a metablock  -->\n				<output type-ref=\"18\"/>\n				<output type-ref=\"19\"/>\n				<output type-ref=\"20\"/>\n			</outputs>\n		</exception>\n		<exception item-id=\"7\">\n			<md:code-name>cn_exception2</md:code-name>\n			<md:display-name xml:lang=\"en\">dn_exception2</md:display-name>\n			<md:display-name xml:lang=\"ja\">dn_ブール</md:display-name>\n			<md:description xml:lang=\"en\">desc_exception2</md:description>\n			<md:description xml:lang=\"ja\">DESC 、ブール型</md:description>\n			<outputs>\n				<output type-ref=\"17\"/>\n				<output type-ref=\"18\"/>\n				<output type-ref=\"19\"/>\n			</outputs>\n		</exception>\n	</exceptions>\n</interface>\n','1','opendof',10,'2015-10-14 13:14:13','2015-10-14 13:14:13',0),(51,'[1:{01000052}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000052}]\">\n    <md:code-name>ENERGY_STATUS_APPARENT</md:code-name>\n    <md:display-name xml:lang=\"en\">Apparent Energy Status</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents the current status of apparent energy production/consumption of an object (energy system, battery, etc.). This may either be measured directly, or computed from the real/active and reactive powers produced/consumed by the object (refer to interface [1:{0221}]).</md:description>\n    <typedefs>\n        <float32 type-id=\"0\" min=\"0.0\" max=\"3.4028235E38\">\n            <md:code-name>Power</md:code-name>\n            <md:display-name xml:lang=\"en\">Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of power.</md:description>\n            <unit>Volt-Ampere (VA)</unit>\n        </float32>\n        <float32 type-id=\"1\" min=\"0.0\" max=\"1.0\">\n            <md:code-name>Factor</md:code-name>\n            <md:display-name xml:lang=\"en\">Factor</md:display-name>\n            <md:description xml:lang=\"en\">A ratio.</md:description>\n        </float32>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:code-name>apparentPower</md:code-name>\n            <md:display-name xml:lang=\"en\">Apparent Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the apparent power output by the object. This is defined as the magnitude of the complex power, which is the vector sum of the active and reactive power.</md:description>\n        </property>\n        <property item-id=\"2\" type-ref=\"1\" read=\"true\" write=\"false\">\n            <md:code-name>powerFactor</md:code-name>\n            <md:display-name xml:lang=\"en\">Power Factor</md:display-name>\n            <md:description xml:lang=\"en\">The ratio of active power to apparent power.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2016-03-02 16:56:27','2016-03-02 16:56:27',0),(52,'[63:{E445}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[63:{E445}]\">\n    <md:code-name>PHOTOVOLTAIC_STATUS</md:code-name>\n    <md:display-name xml:lang=\"en\">Photovoltaic Status</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents the current status of a photovoltaic energy source. This contains the photovoltaic-specific properties in addition to the general energy object.</md:description>\n    <typedefs>\n        <float32 type-id=\"0\">\n            <md:code-name>Temperature</md:code-name>\n            <md:display-name xml:lang=\"en\">Temperature</md:display-name>\n            <md:description xml:lang=\"en\">A measure of temperature, in degrees Celsius.</md:description>\n        </float32>\n        <uint32 type-id=\"1\">\n            <md:display-name xml:lang=\"en\">Solar Irradiance</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the solar radiation flux density, in watts per square meter (W/m^2).</md:description>\n        </uint32>\n    </typedefs>\n    <properties>\n        <property item-id=\"0\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:code-name>temperature</md:code-name>\n            <md:display-name xml:lang=\"en\">Current Temperature</md:display-name>\n            <md:description xml:lang=\"en\">The current measured temperature of the photovoltaic system.</md:description>\n        </property>\n        <property item-id=\"1\" type-ref=\"1\" read=\"true\" write=\"false\">\n            <md:code-name>pyranometer</md:code-name>\n            <md:display-name xml:lang=\"en\">Pyranometer</md:display-name>\n            <md:description xml:lang=\"en\">The current measured broadband solar irradiance across the planar photovoltaic surface.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2016-03-02 16:56:27','2016-03-02 16:56:27',0),(53,'[1:{0211}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0211}]\">\n    <md:code-name>HYGROMETER</md:code-name>\n    <md:display-name xml:lang=\"ja\">湿度計インタフェース</md:display-name>\n    <md:display-name xml:lang=\"en\">Hygrometer</md:display-name>\n    <md:description xml:lang=\"ja\">湿度を検知し，その値を提供するインタフェース</md:description>\n    <md:description xml:lang=\"en\">This interface provides tha value of the humidity.</md:description>\n    <typedefs>\n        <uint16 type-id=\"0\" min=\"0\" max=\"1000\">\n            <md:code-name>Permil</md:code-name>\n            <md:display-name xml:lang=\"ja\">パーミル</md:display-name>\n            <md:display-name xml:lang=\"en\">Permil</md:display-name>\n            <md:description xml:lang=\"ja\">パーミル．千分率．0 から 1000 の値をとる．</md:description>\n            <md:description xml:lang=\"en\">Density. The unit is permil, Part Per Thousand. The range is from 0 to 1000.</md:description>\n            <unit>Permil, Part Per Thousand, ‰.</unit>\n        </uint16>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"ja\">湿度</md:display-name>\n            <md:display-name xml:lang=\"en\">Humidity</md:display-name>\n            <md:description xml:lang=\"ja\">湿度の値を保持するプロパティ．</md:description>\n            <md:description xml:lang=\"en\">This property shows the value of the humidity.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2016-03-02 16:56:27','2016-03-02 17:11:22',1),(54,'[1:{021E}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{021E}]\">\n    <md:display-name xml:lang=\"en\">Bi-directional Power Conditioning System</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents a power conditioning system (a device that transfers and may convert power). It is bi-drectional, and defines to sides - a common bus and a device bus. The common bus would typically be considered the \"inside\" of the system, and the device bus would be the \"outside\" of the system, or the bus that is unique to this device.</md:description>\n    <typedefs>\n        <float32 type-id=\"0\">\n            <md:display-name xml:lang=\"en\">Voltage</md:display-name>\n            <md:description xml:lang=\"en\">A measure of voltage.</md:description>\n            <unit>Volt (V)</unit>\n        </float32>\n        <float32 type-id=\"1\" min=\"0.0\" max=\"500.0\">\n            <md:display-name xml:lang=\"en\">Frequency</md:display-name>\n            <md:description xml:lang=\"en\">A measure of frequency. A value of zero indicates Direct Current (DC).</md:description>\n            <unit>Hertz (Hz)</unit>\n        </float32>\n        <float32 type-id=\"2\">\n            <md:display-name xml:lang=\"en\">Current</md:display-name>\n            <md:description xml:lang=\"en\">A measure of current.</md:description>\n            <unit>Ampere (A)</unit>\n        </float32>\n        <float32 type-id=\"3\">\n            <md:display-name xml:lang=\"en\">Active Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of power.</md:description>\n            <unit>Watt (W)</unit>\n        </float32>\n        <float32 type-id=\"4\">\n            <md:display-name xml:lang=\"en\">Reactive Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of reactive power.</md:description>\n            <unit>Volt-Ampere Reactive (var)</unit>\n        </float32>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Device Bus Voltage</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the voltage on the device bus.</md:description>\n        </property>\n        <property item-id=\"2\" type-ref=\"1\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Device Bus Frequency</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the frequency on the device bus.</md:description>\n        </property>\n        <property item-id=\"3\" type-ref=\"2\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Device Bus Current</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the current flow on the device bus. Values greater than zero indicate power flow to the device bus.</md:description>\n        </property>\n        <property item-id=\"4\" type-ref=\"3\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Device Bus Active Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the active power supplied to the device bus. Values greater than zero indicate power transfer to the device bus.</md:description>\n        </property>\n        <property item-id=\"5\" type-ref=\"4\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Device Bus Reactive Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the reactive power observed on the device bus. Values greater than zero indicate power transfer to the device bus.</md:description>\n        </property>\n        <property item-id=\"6\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Common Bus Voltage</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the voltage on the common bus.</md:description>\n        </property>\n        <property item-id=\"7\" type-ref=\"1\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Common Bus Frequency</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the frequency on the common bus.</md:description>\n        </property>\n        <property item-id=\"8\" type-ref=\"2\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Common Bus Current</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the current flow on the common bus. Values greater than zero indicate power flow to the common bus.</md:description>\n        </property>\n        <property item-id=\"9\" type-ref=\"3\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Common Bus Active Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the active power supplied to the common bus. Values greater than zero indicate power transfer to the common bus.</md:description>\n        </property>\n        <property item-id=\"10\" type-ref=\"4\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Common Bus Reactive Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the reactive power observed on the common bus. Values greater than zero indicate power transfer to the common bus.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2016-03-02 16:56:27','2016-03-21 20:49:15',0),(55,'[1:{0212}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0212}]\">\n    <md:code-name>THERMOMETER</md:code-name>\n    <md:display-name xml:lang=\"ja\">温度計インタフェース</md:display-name>\n    <md:display-name xml:lang=\"en\">Thermometer</md:display-name>\n    <md:description xml:lang=\"ja\">温度を検知し，その値を提供するインタフェース</md:description>\n    <md:description xml:lang=\"en\">This interface provides the value of the temperature.</md:description>\n    <typedefs>\n        <float32 type-id=\"0\" min=\"-273.15\" max=\"10000.0\">\n            <md:code-name>Temperature</md:code-name>\n            <md:display-name xml:lang=\"ja\">温度</md:display-name>\n            <md:display-name xml:lang=\"en\">Temperature</md:display-name>\n            <md:description xml:lang=\"ja\">単位は摂氏．</md:description>\n            <md:description xml:lang=\"en\">The unit is degree(Celsius).</md:description>\n            <unit>°C</unit>\n        </float32>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"ja\">値</md:display-name>\n            <md:display-name xml:lang=\"en\">Temperature</md:display-name>\n            <md:description xml:lang=\"ja\">温度の値を保持するプロパティ．</md:description>\n            <md:description xml:lang=\"en\">This property shows the temperature.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2016-03-02 16:56:27','2016-03-02 17:11:22',1),(56,'[1:{0221}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0221}]\">\n    <md:code-name>ENERGY_STATUS</md:code-name>\n    <md:display-name xml:lang=\"en\">Energy Status</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents the current status of energy production/consumption of an object (energy system, battery, etc.).</md:description>\n    <typedefs>\n        <float32 type-id=\"0\">\n            <md:code-name>Voltage</md:code-name>\n            <md:display-name xml:lang=\"en\">Voltage</md:display-name>\n            <md:description xml:lang=\"en\">A measure of voltage.</md:description>\n            <unit>Volt (V)</unit>\n        </float32>\n        <float32 type-id=\"1\" min=\"0.0\" max=\"500.0\">\n            <md:code-name>Frequency</md:code-name>\n            <md:display-name xml:lang=\"en\">Frequency</md:display-name>\n            <md:description xml:lang=\"en\">A measure of frequency.</md:description>\n            <unit>Hertz (Hz)</unit>\n        </float32>\n        <float32 type-id=\"2\">\n            <md:code-name>Current</md:code-name>\n            <md:display-name xml:lang=\"en\">Current</md:display-name>\n            <md:description xml:lang=\"en\">A measure of current.</md:description>\n            <unit>Ampere (A)</unit>\n        </float32>\n        <float32 type-id=\"3\">\n            <md:code-name>ActivePower</md:code-name>\n            <md:display-name xml:lang=\"en\">Active Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of power.</md:description>\n            <unit>Watt (W)</unit>\n        </float32>\n        <float32 type-id=\"4\">\n            <md:code-name>ReactivePower</md:code-name>\n            <md:display-name xml:lang=\"en\">Reactive Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of power, in volt-ampere reactive (var).</md:description>\n            <unit>Volt-Ampere Reactive (var)</unit>\n        </float32>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:code-name>voltage</md:code-name>\n            <md:display-name xml:lang=\"en\">Voltage</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the voltage output by the object.</md:description>\n        </property>\n        <property item-id=\"2\" type-ref=\"1\" read=\"true\" write=\"false\">\n            <md:code-name>frequency</md:code-name>\n            <md:display-name xml:lang=\"en\">Frequency</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the frequency output by the object. Zero (0) indicates Direct Current (DC), and positive values indicate Alternating Current (AC) at the indicated frequency.</md:description>\n        </property>\n        <property item-id=\"3\" type-ref=\"2\" read=\"true\" write=\"false\">\n            <md:code-name>current</md:code-name>\n            <md:display-name xml:lang=\"en\">Current</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the current flow output by the object. As with power, the sign of the current indicates the flow of current, with positive values representing flow from the object.</md:description>\n        </property>\n        <property item-id=\"4\" type-ref=\"3\" read=\"true\" write=\"false\">\n            <md:code-name>activePower</md:code-name>\n            <md:display-name xml:lang=\"en\">Active Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the active power output by the object. Positive values represent power produced/supplied by the object to an entity (e.g., a power grid), and negative values represent power consumed/withdrawn by the object.</md:description>\n        </property>\n        <property item-id=\"5\" type-ref=\"4\" read=\"true\" write=\"false\">\n            <md:code-name>reactivePower</md:code-name>\n            <md:display-name xml:lang=\"en\">AC Reactive Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of the reactive power observed by the object. Positive values represent power produced/supplied by the object to an entity (e.g., a power grid), and negative values represent power consumed/withdrawn by the object.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2016-03-02 16:56:27','2016-03-21 20:49:15',0),(57,'[1:{0239}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{0239}]\">\n    <md:display-name xml:lang=\"en\">Lifetime Energy Meter</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents the integrated power from a bi-directional meter. This means that it measures the energy used or provided over time, in this case over the lifetime of the providing object. This interface should only be used if a true lifetime aggregation is possible.</md:description>\n    <typedefs>\n        <uint64 type-id=\"0\">\n            <md:display-name xml:lang=\"en\">Energy</md:display-name>\n            <md:description xml:lang=\"en\">The energy exchanged.</md:description>\n            <unit>Watt * Hour (Wh)</unit>\n        </uint64>\n    </typedefs>\n    <properties>\n        <property item-id=\"0\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Output</md:display-name>\n            <md:description xml:lang=\"en\">The output energy.</md:description>\n        </property>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:display-name xml:lang=\"en\">Input</md:display-name>\n            <md:description xml:lang=\"en\">The input energy.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2016-03-02 16:56:27','2016-03-21 20:49:15',0),(58,'[1:{01000053}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000053}]\">\n    <md:code-name>PHASE_ENERGY_STATUS</md:code-name>\n    <md:display-name xml:lang=\"en\">Three-Phase Energy Status</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents the current status of three-phase energy production/consumption of an object (energy system, battery, etc.) \n		This interface consists of parallel arrays, where the status of a given phase uses the same index across all arrays.</md:description>\n    <typedefs>\n        <float32 type-id=\"0\" min=\"0.0\" max=\"3.4028235E38\">\n            <md:code-name>Voltage</md:code-name>\n            <md:display-name xml:lang=\"en\">Voltage</md:display-name>\n            <md:description xml:lang=\"en\">A measure of voltage.</md:description>\n            <unit>Volt (V)</unit>\n        </float32>\n        <float32 type-id=\"1\" min=\"0.0\" max=\"500.0\">\n            <md:code-name>Frequency</md:code-name>\n            <md:display-name xml:lang=\"en\">Frequency</md:display-name>\n            <md:description xml:lang=\"en\">A measure of frequency.</md:description>\n            <unit>Hertz (Hz)</unit>\n        </float32>\n        <float32 type-id=\"2\">\n            <md:code-name>Current</md:code-name>\n            <md:display-name xml:lang=\"en\">Current</md:display-name>\n            <md:description xml:lang=\"en\">A measure of current.</md:description>\n            <unit>Ampere (A)</unit>\n        </float32>\n        <float32 type-id=\"3\">\n            <md:code-name>ActivePower</md:code-name>\n            <md:display-name xml:lang=\"en\">Active Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of real power.</md:description>\n            <unit>Watt (W)</unit>\n        </float32>\n        <float32 type-id=\"4\">\n            <md:code-name>ReactivePower</md:code-name>\n            <md:display-name xml:lang=\"en\">Reactive Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of power.</md:description>\n            <unit>Volt-Ampere Reactive (VAR)</unit>\n        </float32>\n        <float32 type-id=\"5\" min=\"0.0\" max=\"3.4028235E38\">\n            <md:code-name>ApparentPower</md:code-name>\n            <md:display-name xml:lang=\"en\">Apparent Power</md:display-name>\n            <md:description xml:lang=\"en\">A measure of apparent power.</md:description>\n            <unit>Volt-Ampere (VA)</unit>\n        </float32>\n        <float32 type-id=\"6\" min=\"0.0\" max=\"1.0\">\n            <md:code-name>Factor</md:code-name>\n            <md:display-name xml:lang=\"en\">Factor</md:display-name>\n            <md:description xml:lang=\"en\">A ratio.</md:description>\n        </float32>\n        <array type-id=\"7\" type-ref=\"0\" min-length=\"3\" length=\"3\">\n            <md:code-name>ThreePhaseVoltageArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Voltage Array</md:display-name>\n            <md:description xml:lang=\"en\">An array of measurements of voltage.</md:description>\n        </array>\n        <array type-id=\"8\" type-ref=\"1\" min-length=\"3\" length=\"3\">\n            <md:code-name>ThreePhaseFrequencyArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Frequency Array</md:display-name>\n            <md:description xml:lang=\"en\">An array of measurements of frequency.</md:description>\n        </array>\n        <array type-id=\"9\" type-ref=\"2\" min-length=\"3\" length=\"3\">\n            <md:code-name>ThreePhaseCurrentArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Current Array</md:display-name>\n            <md:description xml:lang=\"en\">An array of measurements of current.</md:description>\n        </array>\n        <array type-id=\"10\" type-ref=\"3\" min-length=\"3\" length=\"3\">\n            <md:code-name>ThreePhaseActivePowerArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Active Power Array</md:display-name>\n            <md:description xml:lang=\"en\">An array of measurements of real power.</md:description>\n        </array>\n        <array type-id=\"11\" type-ref=\"4\" min-length=\"3\" length=\"3\">\n            <md:code-name>ThreePhaseReactivePowerArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Reactive Power Array</md:display-name>\n            <md:description xml:lang=\"en\">An array of measurements of reactive power.</md:description>\n        </array>\n        <array type-id=\"12\" type-ref=\"5\" min-length=\"3\" length=\"3\">\n            <md:code-name>ThreePhaseApparentPowerArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Apparent Power Array</md:display-name>\n            <md:description xml:lang=\"en\">An array of measurements of apparent power.</md:description>\n        </array>\n        <array type-id=\"13\" type-ref=\"6\" min-length=\"3\" length=\"3\">\n            <md:code-name>ThreePhaseFactorArray</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Factor Array</md:display-name>\n            <md:description xml:lang=\"en\">An array of power factors.</md:description>\n        </array>\n    </typedefs>\n    <properties>\n        <property item-id=\"1\" type-ref=\"7\" read=\"true\" write=\"false\">\n            <md:code-name>lineToLineVoltage</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Line-to-Line Voltage</md:display-name>\n            <md:description xml:lang=\"en\">Three-phase voltage measurement across two lines. The object model identifies the relationship of the two lines.</md:description>\n        </property>\n        <property item-id=\"2\" type-ref=\"7\" read=\"true\" write=\"false\">\n            <md:code-name>voltage</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Voltage</md:display-name>\n            <md:description xml:lang=\"en\">Three-phase voltage measurement output by the object.</md:description>\n        </property>\n        <property item-id=\"3\" type-ref=\"8\" read=\"true\" write=\"false\">\n            <md:code-name>frequency</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Frequency</md:display-name>\n            <md:description xml:lang=\"en\">Three-phase frequency measurement output by the object. Zero (0) indicates the phase is unavailable or not being used, and positive values indicate Alternating Current (AC) at the indicated frequency.</md:description>\n        </property>\n        <property item-id=\"4\" type-ref=\"9\" read=\"true\" write=\"false\">\n            <md:code-name>current</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Current</md:display-name>\n            <md:description xml:lang=\"en\">Three-phase current flow measurement output by the object. As with power, the sign of the current indicates the flow of current, with positive values representing flow from the object.</md:description>\n        </property>\n        <property item-id=\"5\" type-ref=\"10\" read=\"true\" write=\"false\">\n            <md:code-name>activePower</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Active Power</md:display-name>\n            <md:description xml:lang=\"en\">Three-phase active power measurement output by the object. Positive values represent power produced/supplied by the object to an entity (e.g., a power grid), and negative values represent power consumed/withdrawn by the object.</md:description>\n        </property>\n        <property item-id=\"6\" type-ref=\"11\" read=\"true\" write=\"false\">\n            <md:code-name>reactivePower</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase AC Reactive Power</md:display-name>\n            <md:description xml:lang=\"en\">Three-phase reactive power measurement observed by the object. Positive values represent power produced/supplied by the object to an entity (e.g., a power grid), and negative values represent power consumed/withdrawn by the object.</md:description>\n        </property>\n        <property item-id=\"7\" type-ref=\"12\" read=\"true\" write=\"false\">\n            <md:code-name>apparentPower</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Apparent Power</md:display-name>\n            <md:description xml:lang=\"en\">Three-phase apparent power measurement output by the object. This is defined as the magnitude of the complex power, which is the vector sum of the active and reactive power.</md:description>\n        </property>\n        <property item-id=\"8\" type-ref=\"13\" read=\"true\" write=\"false\">\n            <md:code-name>powerFactor</md:code-name>\n            <md:display-name xml:lang=\"en\">Three-Phase Power Factor</md:display-name>\n            <md:description xml:lang=\"en\">Three-phase ratio of active power to apparent power.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2016-03-02 16:56:27','2016-03-21 20:49:15',0),(59,'[1:{021C}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{021C}]\">\n    <md:code-name>Pyranometer</md:code-name>\n    <md:display-name xml:lang=\"en\">Pyranometer</md:display-name>\n    <md:description xml:lang=\"en\">This interface represents a pyranometer sensor, which measuers the solar irradiance in the operational plane of the device.  This corresponds to the Plane of Array value in the Irradiance model of the SunSpec Alliance Specification. Other data about the device (such as location) are provided on different interfaces.</md:description>\n    <typedefs>\n        <float32 type-id=\"0\">\n            <md:code-name>RadiationFluxDensity</md:code-name>\n            <md:display-name xml:lang=\"en\">Radiation Flux Density</md:display-name>\n            <md:description xml:lang=\"en\">The measure of radiation flux density incident on a surface.</md:description>\n			<unit>Watts per square meter (W/m²)</unit>\n        </float32>\n        <float32 type-id=\"1\">\n            <md:code-name>Insolation</md:code-name>\n            <md:display-name xml:lang=\"en\">Insolation</md:display-name>\n            <md:description xml:lang=\"en\">The measurement of the amount of solar energy received per square meter.</md:description>\n			<unit>Watt hours per square meter (Wh/m²)</unit>\n        </float32>\n    </typedefs>\n    <properties>\n        <property item-id=\"0\" type-ref=\"1\" read=\"true\" write=\"false\">\n            <md:code-name>Insolation</md:code-name>\n            <md:display-name xml:lang=\"en\">Insolation</md:display-name>\n            <md:description xml:lang=\"en\">The measurement of the amount of solar enegery received per square meter.</md:description>\n        </property>\n        <property item-id=\"1\" type-ref=\"0\" read=\"true\" write=\"false\">\n            <md:code-name>Irradiance</md:code-name>\n            <md:display-name xml:lang=\"en\">Irradiance</md:display-name>\n            <md:description xml:lang=\"en\">The measurement of irradiance across the planar surface.</md:description>\n        </property>\n    </properties>\n</interface>\n','1','opendof',10,'2016-03-21 20:42:09','2016-03-21 20:42:09',0),(60,'[1:{01000058}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000058}]\">\n    <md:code-name>ButtonDemoConfiguration</md:code-name>\n    <md:display-name xml:lang=\"en\">Button Demo Configuration Interface</md:display-name>\n    <md:description xml:lang=\"en\">An interface used to configure how a device is connected to a local or remote gateway, as well as the messages and the channel to listen/send on.  This interface is usedused along with the Button Demo Message interface to send messages to others listening on the configured channel.</md:description>\n    <typedefs>\n        <uint8 type-id=\"0\">\n            <md:code-name>buttonCount</md:code-name>\n            <md:display-name xml:lang=\"en\">buttonCount</md:display-name>\n            <md:description xml:lang=\"en\">buttonCount. UInt8 with a range of 0 to 255.</md:description>\n        </uint8>\n		<string type-id=\"1\" encoding=\"3\" length=\"64\">\n			<md:code-name>ipAddress</md:code-name>\n			<md:display-name xml:lang=\"en\">ipAddress</md:display-name>\n			<md:description xml:lang=\"en\">ipAddress or hostname.  String with a maximum length of 64 characters.</md:description>\n		</string>\n		<nullable type-id=\"2\" type-ref=\"1\">\n			<md:code-name>optionalIpAddress</md:code-name>\n			<md:display-name xml:lang=\"en\">optionalIpAddress</md:display-name>\n			<md:description xml:lang=\"en\">optional ipAddress.  Nullable String with a maximum length of 64 characters if given.</md:description>\n		</nullable>\n        <uint16 type-id=\"3\">\n            <md:code-name>port</md:code-name>\n            <md:display-name xml:lang=\"en\">port</md:display-name>\n            <md:description xml:lang=\"en\">port. UInt16 with a range of 0 to 65535.</md:description>\n        </uint16>\n		<nullable type-id=\"4\" type-ref=\"3\">\n			<md:code-name>optionalPort</md:code-name>\n			<md:display-name xml:lang=\"en\">optionalPort</md:display-name>\n			<md:description xml:lang=\"en\">optionalPort.  Nullable Uint16 with a range of 0 to 65535 if given.</md:description>\n		</nullable>\n		<oid type-id=\"5\">\n			<md:code-name>groupAddress</md:code-name>\n			<md:display-name xml:lang=\"en\">groupAddress</md:display-name>\n			<md:description xml:lang=\"en\">groupAddress.  A DOFObjectID which identifies the group.</md:description>\n		</oid>\n		<nullable type-id=\"6\" type-ref=\"5\">\n			<md:code-name>optionalGroupAddress</md:code-name>\n			<md:display-name xml:lang=\"en\">optionalGroupAddress</md:display-name>\n			<md:description xml:lang=\"en\">optionalGroupAddress.  Nullable DOFObjectID which identifies the optional group if given.</md:description>\n		</nullable>\n        <uint8 type-id=\"7\">\n            <md:code-name>connectionType</md:code-name>\n            <md:display-name xml:lang=\"en\">connectionType</md:display-name>\n            <md:description xml:lang=\"en\">connectionType. An enumerated value for the connection type. There are four values: Not Configured (0), TCP (1), UDP (3) Secure Multicast Group (4).</md:description>\n        </uint8>\n        <uint8 type-id=\"8\">\n            <md:code-name>buttonNumber</md:code-name>\n            <md:display-name xml:lang=\"en\">buttonNumber</md:display-name>\n            <md:description xml:lang=\"en\">buttonNumber. UInt8 with a range of 1 to 255.</md:description>\n        </uint8>\n        <uint8 type-id=\"9\">\n            <md:code-name>channel</md:code-name>\n            <md:display-name xml:lang=\"en\">channel</md:display-name>\n            <md:description xml:lang=\"en\">channel. UInt8 with a range of from 0 to 255.</md:description>\n        </uint8>\n		<string type-id=\"10\" encoding=\"3\" length=\"32\">\n			<md:code-name>message</md:code-name>\n			<md:display-name xml:lang=\"en\">message</md:display-name>\n			<md:description xml:lang=\"en\">message.  String with a maximum length allowed of 32 characters.</md:description>\n		</string>\n   		<string type-id=\"11\" encoding=\"3\" length=\"32\">\n			<md:code-name>wifiSsid</md:code-name>\n			<md:display-name xml:lang=\"en\">wifiSsid</md:display-name>\n			<md:description xml:lang=\"en\">wifiSsid.  String with a maximum length allowed of 32 characters.</md:description>\n		</string>\n   		<string type-id=\"12\" encoding=\"3\" length=\"32\">\n			<md:code-name>wifiPassword</md:code-name>\n			<md:display-name xml:lang=\"en\">wifiPassword</md:display-name>\n			<md:description xml:lang=\"en\">wifiPassword.  String with a maximum length allowed of 32 characters.</md:description>\n		</string>\n    </typedefs>\n	<properties>\n		<property item-id=\"0\" type-ref= \"0\" read=\"true\" write=\"false\">\n				<md:code-name>buttonCount</md:code-name>\n				<md:display-name xml:lang=\"en\">buttonCount</md:display-name>\n				<md:description xml:lang=\"en\">The read only button count.</md:description>\n		</property>\n		<property item-id=\"1\" type-ref= \"9\" read=\"true\" write=\"true\">\n				<md:code-name>channel</md:code-name>\n				<md:display-name xml:lang=\"en\">channel</md:display-name>\n				<md:description xml:lang=\"en\">The read/write channel.</md:description>\n		</property>\n	</properties>\n	<methods>\n		<method item-id=\"2\">\n			<md:code-name>tcpConnection</md:code-name>\n			<md:display-name xml:lang=\"en\">tcpConnection</md:display-name>\n			<md:description xml:lang=\"en\">void tcpConnection(String optionalIpAddress, UInt16 optionalPort).  ipAddress and port to be used, or use default if they are given as null.</md:description>\n			<inputs>\n				<input type-ref=\"2\">\n					<md:code-name>optionalIpAddress</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalIpAddress</md:display-name>\n					<md:description xml:lang=\"en\">The IP address or hostname to connect to.  May be null if default is to be used. </md:description>\n				</input>\n				<input type-ref=\"4\">\n					<md:code-name>optionalPort</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalPort</md:display-name>\n					<md:description xml:lang=\"en\">The port to connect to.  May be null if default is to be used.</md:description>\n				</input>\n			</inputs>\n		</method>\n		<method item-id=\"3\">\n			<md:code-name>udpConnection</md:code-name>\n			<md:display-name xml:lang=\"en\">udpConnection</md:display-name>\n			<md:description xml:lang=\"en\">void udpConnection(String optionalIpAddress, UInt16 optionalPort).  ipAddress and port to be used, or use default if they are given as null.</md:description>\n			<inputs>\n				<input type-ref=\"2\">\n					<md:code-name>optionalIpAddress</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalIpAddress</md:display-name>\n					<md:description xml:lang=\"en\">The IP address or hostname to connect to.  May be null if default is to be used.</md:description>\n				</input>\n				<input type-ref=\"4\">\n					<md:code-name>optionalPort</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalPort</md:display-name>\n					<md:description xml:lang=\"en\">The port to connect to.  May be null if default is to be used.</md:description>\n				</input>\n			</inputs>\n		</method>\n		<method item-id=\"4\">\n			<md:code-name>secureMulticastConnection</md:code-name>\n			<md:display-name xml:lang=\"en\">secureMulticastConnection</md:display-name>\n			<md:description xml:lang=\"en\">void secureMulticastConnection(String optionalIpAddress, Uint16 optionalPort, DOFObjectID optionalGroupAddress).  Default ipAddress, port and groupAddress to be used if they are given as null.</md:description>\n			<inputs>\n				<input type-ref=\"2\">\n					<md:code-name>optionalIpAddress</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalIpAddress</md:display-name>\n					<md:description xml:lang=\"en\">The IP address to connect to.  May be null if default is to be used.</md:description>\n				</input>\n				<input type-ref=\"4\">\n					<md:code-name>optionalPort</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalPort</md:display-name>\n					<md:description xml:lang=\"en\">The port to connect to.  May be null if default is to be used.</md:description>\n				</input>\n				<input type-ref=\"6\">\n					<md:code-name>optionalGroupAddress</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalGroupAddress</md:display-name>\n					<md:description xml:lang=\"en\">The SGMP Group address to connect to.  May be null if default is to be used.</md:description>\n				</input>\n			</inputs>\n		</method>\n		<method item-id=\"5\">\n			<md:code-name>displayConfiguration</md:code-name>\n			<md:display-name xml:lang=\"en\">displayConfiguration</md:display-name>\n			<md:description xml:lang=\"en\">void displayConfiguration().  Causes a device to display its configuration.</md:description>\n		</method>\n		<method item-id=\"6\">\n			<md:code-name>getConfiguration</md:code-name>\n			<md:display-name xml:lang=\"en\">getConfiguration</md:display-name>\n			<md:description xml:lang=\"en\">Get the current connection configuration.</md:description>\n			<outputs>\n				<output type-ref=\"2\">\n					<md:code-name>optionalIpAddress</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalIpAddress</md:display-name>\n					<md:description xml:lang=\"en\">The IP address to connect to.  May be null if an ipAddress is not set for the connection.</md:description>\n				</output>\n				<output type-ref=\"4\">\n					<md:code-name>optionalPort</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalPort</md:display-name>\n					<md:description xml:lang=\"en\">The port to connect to.  May be null if a port is not set for the connection.</md:description>\n				</output>\n				<output type-ref=\"6\">\n					<md:code-name>optionalGroupAddress</md:code-name>\n					<md:display-name xml:lang=\"en\">optionalGroupAddress</md:display-name>\n					<md:description xml:lang=\"en\">The SGMP Group address to connect to.  May be null if a secure multicast group address is not configured.</md:description>\n				</output>\n				<output type-ref=\"7\">\n					<md:code-name>connectionType</md:code-name>\n					<md:display-name xml:lang=\"en\">connectionType</md:display-name>\n					<md:description xml:lang=\"en\">The connection type.</md:description>\n				</output>\n			</outputs>\n		</method>\n		<method item-id=\"7\">\n			<md:code-name>saveConfiguration</md:code-name>\n			<md:display-name xml:lang=\"en\">saveConfiguration</md:display-name>\n			<md:description xml:lang=\"en\">void saveConfiguration().  Causes a device to save its configuration so that the current configuration becomes the default.</md:description>\n		</method>\n		<method item-id=\"8\">\n			<md:code-name>setButtonMessage</md:code-name>\n			<md:display-name xml:lang=\"en\">setButtonMessage</md:display-name>\n			<md:description xml:lang=\"en\">void setButtonMessage(UInt8 buttonNumber, String message).  Causes a message to be associated with a given button. (Zero will cause a ButtonOutOfRange exception.)</md:description>\n			<inputs>\n				<input type-ref=\"8\">\n					<md:code-name>buttonNumber</md:code-name>\n					<md:display-name xml:lang=\"en\">buttonNumber</md:display-name>\n					<md:description xml:lang=\"en\">The buttonNumber to associate the message with.</md:description>\n				</input>\n				<input type-ref=\"10\">\n					<md:code-name>message</md:code-name>\n					<md:display-name xml:lang=\"en\">message</md:display-name>\n					<md:description xml:lang=\"en\">The message to associate with the given button.</md:description>\n				</input>\n			</inputs>\n		</method>\n		<method item-id=\"9\">\n			<md:code-name>configureWiFi</md:code-name>\n			<md:display-name xml:lang=\"en\">configureWiFi</md:display-name>\n			<md:description xml:lang=\"en\">void configureWiFi(String wifiSsid, String wifiPassword).  Configures the WiFi to the given ssid and password.</md:description>\n			<inputs>\n				<input type-ref=\"11\">\n					<md:code-name>wifiSsid</md:code-name>\n					<md:display-name xml:lang=\"en\">wifiSsid</md:display-name>\n					<md:description xml:lang=\"en\">The WiFi SSID to use.</md:description>\n				</input>\n				<input type-ref=\"10\">\n					<md:code-name>wifiPassword</md:code-name>\n					<md:display-name xml:lang=\"en\">wifiPassword</md:display-name>\n					<md:description xml:lang=\"en\">The password for the given SSID.</md:description>\n				</input>\n			</inputs>\n		</method>\n    </methods>\n	<exceptions>\n		<exception item-id=\"10\">\n			<md:code-name>ButtonOutOfRange</md:code-name>\n			<md:display-name xml:lang=\"en\">ButtonOutOfRange</md:display-name>\n			<md:description xml:lang=\"en\">The given button number was out of range</md:description>\n		</exception>\n	</exceptions>\n</interface>\n','1','opendof',10,'2016-03-28 18:45:47','2016-04-04 13:12:10',1),(61,'[1:{01000057}]','<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interface xmlns=\"http://opendof.org/schema/interface-repository\" xmlns:md=\"http://opendof.org/schema/interface-repository-meta\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://opendof.org/schema/interface-repository http://opendof.org/schema/interface-repository.xsd \" iid=\"[1:{01000057}]\">\n    <md:code-name>ButtonDemoMessage</md:code-name>\n    <md:display-name xml:lang=\"en\">Button Demo Message Interface</md:display-name>\n    <md:description xml:lang=\"en\">Provides a very basic message sending method.</md:description>\n    <typedefs>\n        <uint8 type-id=\"0\">\n            <md:code-name>channel</md:code-name>\n            <md:display-name xml:lang=\"en\">channel</md:display-name>\n            <md:description xml:lang=\"en\">channel. UInt8 with a range of from 0 to 255.</md:description>\n        </uint8>\n		<string type-id=\"1\" encoding=\"3\" length=\"32\">\n			<md:code-name>message</md:code-name>\n			<md:display-name xml:lang=\"en\">message</md:display-name>\n			<md:description xml:lang=\"en\">message.  String with a maximum length allowed of 32 characters.</md:description>\n		</string>\n    </typedefs>\n	<methods>\n		<method item-id=\"0\">\n			<md:code-name>buttonMessage</md:code-name>\n			<md:display-name xml:lang=\"en\">buttonMessage</md:display-name>\n			<md:description xml:lang=\"en\">Used to send a message on the specified channel.</md:description>\n			<inputs>\n				<input type-ref=\"0\">\n					<md:code-name>channel</md:code-name>\n					<md:display-name xml:lang=\"en\">channel</md:display-name>\n					<md:description xml:lang=\"en\">The channel (UInt8) that the message is associated with.</md:description>\n				</input>\n				<input type-ref=\"1\">\n					<md:code-name>message</md:code-name>\n					<md:display-name xml:lang=\"en\">message</md:display-name>\n					<md:description xml:lang=\"en\">The message.</md:description>\n				</input>\n			</inputs>\n		</method>\n	</methods>\n</interface>\n','1','opendof',10,'2016-03-28 18:46:13','2016-04-04 13:12:10',1);
/*!40000 ALTER TABLE `interface` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `registry`
--

DROP TABLE IF EXISTS `registry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry` (
  `registryPk` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary auto incrementing key of registry and size categories',
  `registry` int(11) NOT NULL COMMENT 'The registry 1 to 62',
  `size` tinyint(4) NOT NULL COMMENT 'Size category 1 is 1 byte, 2 is 2 bytes, 3 is 4 bytes',
  `next` int(11) NOT NULL COMMENT 'The next iid to be given out for the registry/size',
  PRIMARY KEY (`registryPk`),
  UNIQUE KEY `uq_registry_registry_size` (`registry`,`size`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Table of all Registry and size categories';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry`
--

LOCK TABLES `registry` WRITE;
/*!40000 ALTER TABLE `registry` DISABLE KEYS */;
/*!40000 ALTER TABLE `registry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reserved`
--

DROP TABLE IF EXISTS `reserved`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reserved` (
  `reservedPk` int(11) NOT NULL AUTO_INCREMENT,
  `registryFk` int(11) NOT NULL COMMENT 'registry PK',
  `iid` int(11) NOT NULL COMMENT 'The reserved iid',
  `submitterFk` bigint(20) NOT NULL,
  `reservedDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Original reserved time',
  `nextGrant` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'time of required renewal',
  PRIMARY KEY (`reservedPk`),
  KEY `fk_reserved_registryFk_registry` (`registryFk`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Table of reserved Interface ID';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reserved`
--

LOCK TABLES `reserved` WRITE;
/*!40000 ALTER TABLE `reserved` DISABLE KEYS */;
/*!40000 ALTER TABLE `reserved` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `submitter`
--

DROP TABLE IF EXISTS `submitter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `submitter` (
  `submitterPk` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The submitters primary auto incrementing key',
  `name` varchar(80) COLLATE utf8_bin NOT NULL COMMENT 'The name of the submitter',
  `email` varchar(254) COLLATE utf8_bin NOT NULL COMMENT 'submitters email ',
  `description` varchar(256) COLLATE utf8_bin DEFAULT NULL COMMENT 'Brief information about the submitter',
  `joinedDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Time and date the submitter joined',
  `isGroup` tinyint(1) NOT NULL COMMENT 'Does this submitter represent a group',
  PRIMARY KEY (`submitterPk`),
  UNIQUE KEY `creator_index` (`name`),
  UNIQUE KEY `email_index` (`email`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='The owner table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `submitter`
--

LOCK TABLES `submitter` WRITE;
/*!40000 ALTER TABLE `submitter` DISABLE KEYS */;
INSERT INTO `submitter` VALUES (9,'Chad Adams','Not Known1443459578883',NULL,'2015-09-28 10:59:50',0),(10,'PSLCL','Not Known1443459578884',NULL,'2015-09-28 10:59:57',1);
/*!40000 ALTER TABLE `submitter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `submittergroup`
--

DROP TABLE IF EXISTS `submittergroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `submittergroup` (
  `groupFk` bigint(10) unsigned NOT NULL COMMENT 'submitter.submitterPk representing this group',
  `managerFk` bigint(11) unsigned DEFAULT NULL COMMENT 'submitter.submitterPk who is the manager of  the group',
  `memberFk` bigint(10) unsigned NOT NULL COMMENT 'submitters.submitterPk of the group members',
  KEY `submittergroup_managerFk-Idx` (`managerFk`),
  KEY `submittergroup_groupFk-Idx` (`groupFk`),
  KEY `submittergroup_membersFk-Idx` (`memberFk`),
  CONSTRAINT `submittergroup_groupFk_Cst` FOREIGN KEY (`groupFk`) REFERENCES `submitter` (`submitterPk`),
  CONSTRAINT `submittergroup_managerFk_Cst` FOREIGN KEY (`managerFk`) REFERENCES `submitter` (`submitterPk`),
  CONSTRAINT `submitergroup_memberFk_Cst` FOREIGN KEY (`memberFk`) REFERENCES `submitter` (`submitterPk`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='The group creator table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `submittergroup`
--

LOCK TABLES `submittergroup` WRITE;
/*!40000 ALTER TABLE `submittergroup` DISABLE KEYS */;
INSERT INTO `submittergroup` VALUES (10,9,9);
/*!40000 ALTER TABLE `submittergroup` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2016-05-24  9:27:13
